      REAL*8 FUNCTION ee_bbmumu(p1,p2,p3,p4,p5,p6)

      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT double COMPLEX (c)

      DIMENSION p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),p6(0:3)
      DIMENSION p34(0:3),p16(0:3),p25(0:3),p123(0:3),p125(0:3),
     &  p134(0:3),p156(0:3),p235(0:3),p345(0:3),p356(0:3)

      DIMENSION cres4(2,2,2,2),cres5(2,2,2,2),cres9(2,2,2,2),
     &  cres10(2,2,2,2),cres14(2,2,2,2),cres15(2,2,2,2),cres16(2,2,2,2),
     &  cres20(2,2,2,2),cres21(2,2,2,2),cres22(2,2,2,2),cres23(2,2,2,2),
     &  cres24(2,2,2,2),cres25(2,2,2,2),cres26(2,2,2,2),cres27(2,2,2,2),
     &  cres28(2,2,2,2),cres29(2,2,2,2),cres30(2,2,2,2),cres31(2,2,2,2),
     &  cres32(2,2,2,2),cres33(2,2,2,2),cres34(2,2,2,2),cres35(2,2,2,2),
     &  cres36(2,2,2,2),c34h(2,2),cres17(2,2,2,2)

      STRUCTURE/polcom/
      double COMPLEX e(0:3),ek0,v
      END STRUCTURE
      RECORD/polcom/c12f(2),c12z(2),c34f(2,2),c34z(2,2),
     &  c56z(2),c56f(2)

      STRUCTURE/tu0/
      double COMPLEX a(2),c(2)
      END STRUCTURE
      RECORD/tu0/l1_34f(2,2),l1_34z(2,2),l5_12z(2),l5_34z(2,2),l1_56z(2)
     &  ,l5_12f(2),l5_34f(2,2),l1_56f(2)

      STRUCTURE/td0/
      double COMPLEX a(2),b(2)
      END STRUCTURE
      RECORD/td0/r2_34f(2,2),r2_34z(2,2),r6_12z(2),r6_34z(2,2),r2_56z(2)
     &  ,r6_12f(2),r6_34f(2,2),r2_56f(2)

      STRUCTURE/t/
      double COMPLEX a(2,2),b(2,2),c(2,2),d(2,2)
      END STRUCTURE
      RECORD/t/v3_4f(0:3),v3_4z(0:3),u3_12f(2),u3_12z(2),u3_56z(2),
     &  d4_12f(2),d4_12z(2),d4_56f(2),d4_56z(2),u3_56f(2),v3_4h,
     &  dia14(2,2),dia15(2,2),dia16(2,2),dia17(2,2),dia26(2,2),
     &  dia27(2,2),dia28(2,2),dia29(2,2)

      COMMON/abhigg/rmb,rmb2,rmh,rmh2,gamh,rhzz,rhww,rhbb
      COMMON/abparb/rmw2,gamw,rmz2,rmt2,rcotw,pi,alfa_me,qcdcoupl,
     &  qcdcor_cc,qcdcor_nc,qcdcor_h
      COMMON/abparc/czipr,ccz,cwipr,ccw,chipr,cch,caipr,cca
      COMMON/abcoup/fer,fel,zer,zel,f3l,f4l,f5l,f6l,z3l,z4l,z5l,z6l,
     &  f3r,f4r,f5r,f6r,z3r,z4r,z5r,z6r,wcl,delz,xf,xz,yf,yz,zz
      COMMON/abcopl/zvl,zvr,fqdl,fqdr,zqdl,zqdr,fqul,fqur,zqul,zqur
      COMMON/abflag/icc,icc3,i3e,i4e,i3q,i5q,iqu,i34e,i56ve,ibbveve,iid,
     &  imix,icoul,istrcor,idownl,idownr,ianc
*el2
     &  ,izz,izg,izg34,izg56,inc08,igamgam,itch
*endel2

      PARAMETER (czero=(0.d0,0.d0),cuno=(1.d0,0.d0),cim=(0.d0,1.d0))

      data ifirst/1/

* p_q -- p_q=p1p2,p=p1,q=p2
      p1p2=p1(0)*p2(0)-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)
      s=2.d0*p1p2
      ss=sqrt(s)
      e=ss/2.d0
      quqd=s/2.d0
      p1k0=p1(0)-p1(1)
      p2k0=p2(0)-p2(1)
      cdz=-1.d0/(s*czipr-rmz2+ccz)
      dph=-1.d0/s
      fac1=(dph*fer)
      fac2=(dph*fel)
      cfac1z=(cdz*zer)/fac1
      cfac2z=(cdz*zel)/fac2
* T10 -- qu=p1,qd=p2,v=0,a=c12f,cr=fac1,cl=fac2,nsum=0
      eps_0=-p1(2)*p2(3)+p2(2)*p1(3)
      ceps_0=eps_0*cim
      auxa=-quqd+p1k0*p2(0)+p2k0*p1(0)
      c12f(1).e(0)=fac1*(auxa+ceps_0)
      c12f(2).e(0)=fac2*(auxa-ceps_0)
      c12z(1).e(0)=cfac1z*c12f(1).e(0)
      c12z(2).e(0)=cfac2z*c12f(2).e(0)
* T10 -- qu=p1,qd=p2,v=1,a=c12f,cr=fac1,cl=fac2,nsum=0
      auxa=-quqd+p1k0*p2(1)+p2k0*p1(1)
      c12f(1).e(1)=fac1*(auxa+ceps_0)
      c12f(2).e(1)=fac2*(auxa-ceps_0)
      c12z(1).e(1)=cfac1z*c12f(1).e(1)
      c12z(2).e(1)=cfac2z*c12f(2).e(1)
* T10 -- qu=p1,qd=p2,v=2,a=c12f,cr=fac1,cl=fac2,nsum=0
      eps_0=-p1k0*p2(3)+p2k0*p1(3)
      ceps_0=eps_0*cim
      auxa=p1k0*p2(2)+p2k0*p1(2)
      c12f(1).e(2)=fac1*(auxa+ceps_0)
      c12f(2).e(2)=fac2*(auxa-ceps_0)
      c12z(1).e(2)=cfac1z*c12f(1).e(2)
      c12z(2).e(2)=cfac2z*c12f(2).e(2)
* T10 -- qu=p1,qd=p2,v=3,a=c12f,cr=fac1,cl=fac2,nsum=0
      eps_0=p1k0*p2(2)-p2k0*p1(2)
      ceps_0=eps_0*cim
      auxa=p1k0*p2(3)+p2k0*p1(3)
      c12f(1).e(3)=fac1*(auxa+ceps_0)
      c12f(2).e(3)=fac2*(auxa-ceps_0)
      c12z(1).e(3)=cfac1z*c12f(1).e(3)
      c12z(2).e(3)=cfac2z*c12f(2).e(3)
      DO i=1,2
* pk0 -- p=c12f(i).e
        c12f(i).ek0=c12f(i).e(0)-c12f(i).e(1)
      END DO
      DO i=1,2
* pk0 -- p=c12z(i).e
        c12z(i).ek0=c12z(i).e(0)-c12z(i).e(1)
      END DO
*********************AUTOM***********************************************
*
* pk0 -- p=p3
      p3k0=p3(0)-p3(1)
* pk0 -- p=p4
      p4k0=p4(0)-p4(1)
* pk0 -- p=p5
      p5k0=p5(0)-p5(1)
* pk0 -- p=p6
      p6k0=p6(0)-p6(1)
*   Impulsi dei propagatori
      DO m=0,3
        p34(m)=p3(m)+p4(m)
        p16(m)=-p1(m)+p6(m)
        p25(m)=-p2(m)+p5(m)
        p123(m)=-p1(m)-p2(m)+p3(m)
        p125(m)=-p1(m)+p25(m)
        p134(m)=-p1(m)+p34(m)
        p156(m)=p5(m)+p16(m)
        p235(m)=p25(m)+p3(m)
        p345(m)=p34(m)+p5(m)
        p356(m)=p3(m)+p5(m)+p6(m)
      END DO
* pk0 -- p=p123
      p123k0=p123(0)-p123(1)
* p.q -- p.q=p123q,p=p123,q=p123
      p123q=p123(0)*p123(0)-p123(1)*p123(1)-p123(2)*p123(2)-p123
     &  (3)*p123(3)
* pk0 -- p=p125
      p125k0=p125(0)-p125(1)
* p.q -- p.q=p125q,p=p125,q=p125
      p125q=p125(0)*p125(0)-p125(1)*p125(1)-p125(2)*p125(2)-p125
     &  (3)*p125(3)
* pk0 -- p=p134
      p134k0=p134(0)-p134(1)
* p.q -- p.q=p134q,p=p134,q=p134
      p134q=p134(0)*p134(0)-p134(1)*p134(1)-p134(2)*p134(2)-p134
     &  (3)*p134(3)
* pk0 -- p=p156
      p156k0=p156(0)-p156(1)
* p.q -- p.q=p156q,p=p156,q=p156
      p156q=p156(0)*p156(0)-p156(1)*p156(1)-p156(2)*p156(2)-p156
     &  (3)*p156(3)
* pk0 -- p=p235
      p235k0=p235(0)-p235(1)
* p.q -- p.q=p235q,p=p235,q=p235
      p235q=p235(0)*p235(0)-p235(1)*p235(1)-p235(2)*p235(2)-p235
     &  (3)*p235(3)
* pk0 -- p=p345
      p345k0=p345(0)-p345(1)
* p.q -- p.q=p345q,p=p345,q=p345
      p345q=p345(0)*p345(0)-p345(1)*p345(1)-p345(2)*p345(2)-p345
     &  (3)*p345(3)
* pk0 -- p=p356
      p356k0=p356(0)-p356(1)
* p.q -- p.q=p356q,p=p356,q=p356
      p356q=p356(0)*p356(0)-p356(1)*p356(1)-p356(2)*p356(2)-p356
     &  (3)*p356(3)
      IF (imix.EQ.-1.or.imix.eq.-2) then
* quqd -- p=p3,q=p4
        quqd=p3(0)*p4(0)-p3(1)*p4(1)-p3(2)*p4(2)-p3(3)*p4(3)
        df=-2.d0*(quqd+rmb2)
        cdz=-(2.d0*(quqd+rmb2)*czipr-rmz2+ccz)
* T -- qu=p3,qd=p4,v=0,a=v3_4f(0).a,b=v3_4f(0).b,c=v3_4f(0).c,d=v3_4f(0).d
* cr=fqdr,cl=fqdl,nsum=0
        eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
        ceps_0=eps_0*cim
        ceps_1=p3(3)*cim
        ceps_2=p4(3)*cim
        auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
        v3_4f(0).a(1,1)=fqdr*(auxa+ceps_0)
        v3_4f(0).a(2,2)=fqdl*(auxa-ceps_0)
        v3_4f(0).b(1,2)=-fqdl*(p4(2)+ceps_2)
        v3_4f(0).b(2,1)=fqdr*(p4(2)-ceps_2)
        v3_4f(0).c(1,2)=fqdr*(p3(2)+ceps_1)
        v3_4f(0).c(2,1)=fqdl*(-p3(2)+ceps_1)
        v3_4f(0).d(1,1)=fqdl
        v3_4f(0).d(2,2)=fqdr
* T -- qu=p3,qd=p4,v=1,a=v3_4f(1).a,b=v3_4f(1).b,c=v3_4f(1).c,d=v3_4f(1).d,
* cr=fqdr,cl=fqdl,nsum=0
        auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
        v3_4f(1).a(1,1)=fqdr*(auxa+ceps_0)
        v3_4f(1).a(2,2)=fqdl*(auxa-ceps_0)
        v3_4f(1).b(1,2)=-fqdl*(p4(2)+ceps_2)
        v3_4f(1).b(2,1)=fqdr*(p4(2)-ceps_2)
        v3_4f(1).c(1,2)=fqdr*(p3(2)+ceps_1)
        v3_4f(1).c(2,1)=fqdl*(-p3(2)+ceps_1)
        v3_4f(1).d(1,1)=fqdl
        v3_4f(1).d(2,2)=fqdr
* T -- qu=p3,qd=p4,v=2,a=v3_4f(2).a,b=v3_4f(2).b,c=v3_4f(2).c,d=v3_4f(2).d,
* cr=fqdr,cl=fqdl,nsum=0
        eps_0=-p3k0*p4(3)+p4k0*p3(3)
        ceps_0=eps_0*cim
        auxa=p3k0*p4(2)+p4k0*p3(2)
        v3_4f(2).a(1,1)=fqdr*(auxa+ceps_0)
        v3_4f(2).a(2,2)=fqdl*(auxa-ceps_0)
        v3_4f(2).b(1,2)=-fqdl*p4k0
        v3_4f(2).b(2,1)=fqdr*p4k0
        v3_4f(2).c(1,2)=fqdr*p3k0
        v3_4f(2).c(2,1)=-fqdl*p3k0
* T -- qu=p3,qd=p4,v=3,a=v3_4f(3).a,b=v3_4f(3).b,c=v3_4f(3).c,d=v3_4f(3).d,
* cr=fqdr,cl=fqdl,nsum=0
        eps_0=p3k0*p4(2)-p4k0*p3(2)
        ceps_0=eps_0*cim
        ceps_1=p3k0*cim
        ceps_2=p4k0*cim
        auxa=+p3k0*p4(3)+p4k0*p3(3)
        v3_4f(3).a(1,1)=fqdr*(auxa+ceps_0)
        v3_4f(3).a(2,2)=fqdl*(auxa-ceps_0)
        v3_4f(3).b(1,2)=-fqdl*ceps_2
        v3_4f(3).b(2,1)=-fqdr*ceps_2
        v3_4f(3).c(1,2)=fqdr*ceps_1
        v3_4f(3).c(2,1)=fqdl*ceps_1
        DO m=0,3
* mline -- res=c34f(&).e(m),abcd=v3_4f(m).,m1=rmb,m2=(-rmb),den=df
          DO iut=1,2
            DO jut=1,2
              c34f(iut,jut).e(m)=(v3_4f(m).a(iut,jut)+rmb*v3_4f(m).b(iut
     &          ,jut)+(-rmb)*v3_4f(m).c(iut,jut)+rmb*(-rmb)*v3_4f(m).
     &          d(iu
     &          t,jut))/df
            ENDDO
          ENDDO
        END DO
* T -- qu=p3,qd=p4,v=0,a=v3_4z(0).a,b=v3_4z(0).b,c=v3_4z(0).c,d=v3_4z(0).d,
* cr=zqdr,cl=zqdl,nsum=0
        eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
        ceps_0=eps_0*cim
        ceps_1=p3(3)*cim
        ceps_2=p4(3)*cim
        auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
        v3_4z(0).a(1,1)=zqdr*(auxa+ceps_0)
        v3_4z(0).a(2,2)=zqdl*(auxa-ceps_0)
        v3_4z(0).b(1,2)=-zqdl*(p4(2)+ceps_2)
        v3_4z(0).b(2,1)=zqdr*(p4(2)-ceps_2)
        v3_4z(0).c(1,2)=zqdr*(p3(2)+ceps_1)
        v3_4z(0).c(2,1)=zqdl*(-p3(2)+ceps_1)
        v3_4z(0).d(1,1)=zqdl
        v3_4z(0).d(2,2)=zqdr
* T -- qu=p3,qd=p4,v=1,a=v3_4z(1).a,b=v3_4z(1).b,c=v3_4z(1).c,d=v3_4z(1).d,
* cr=zqdr,cl=zqdl,nsum=0
        auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
        v3_4z(1).a(1,1)=zqdr*(auxa+ceps_0)
        v3_4z(1).a(2,2)=zqdl*(auxa-ceps_0)
        v3_4z(1).b(1,2)=-zqdl*(p4(2)+ceps_2)
        v3_4z(1).b(2,1)=zqdr*(p4(2)-ceps_2)
        v3_4z(1).c(1,2)=zqdr*(p3(2)+ceps_1)
        v3_4z(1).c(2,1)=zqdl*(-p3(2)+ceps_1)
        v3_4z(1).d(1,1)=zqdl
        v3_4z(1).d(2,2)=zqdr
* T -- qu=p3,qd=p4,v=2,a=v3_4z(2).a,b=v3_4z(2).b,c=v3_4z(2).c,d=v3_4z(2).d,
* cr=zqdr,cl=zqdl,nsum=0
        eps_0=-p3k0*p4(3)+p4k0*p3(3)
        ceps_0=eps_0*cim
        auxa=p3k0*p4(2)+p4k0*p3(2)
        v3_4z(2).a(1,1)=zqdr*(auxa+ceps_0)
        v3_4z(2).a(2,2)=zqdl*(auxa-ceps_0)
        v3_4z(2).b(1,2)=-zqdl*p4k0
        v3_4z(2).b(2,1)=zqdr*p4k0
        v3_4z(2).c(1,2)=zqdr*p3k0
        v3_4z(2).c(2,1)=-zqdl*p3k0
* T -- qu=p3,qd=p4,v=3,a=v3_4z(3).a,b=v3_4z(3).b,c=v3_4z(3).c,d=v3_4z(3).d,
* cr=zqdr,cl=zqdl,nsum=0
        eps_0=p3k0*p4(2)-p4k0*p3(2)
        ceps_0=eps_0*cim
        ceps_1=p3k0*cim
        ceps_2=p4k0*cim
        auxa=+p3k0*p4(3)+p4k0*p3(3)
        v3_4z(3).a(1,1)=zqdr*(auxa+ceps_0)
        v3_4z(3).a(2,2)=zqdl*(auxa-ceps_0)
        v3_4z(3).b(1,2)=-zqdl*ceps_2
        v3_4z(3).b(2,1)=-zqdr*ceps_2
        v3_4z(3).c(1,2)=zqdr*ceps_1
        v3_4z(3).c(2,1)=zqdl*ceps_1
        DO m=0,3
* mline -- res=c34z(&).e(m),abcd=v3_4z(m).,m1=rmb,m2=(-rmb),den=cdz
          DO iut=1,2
            DO jut=1,2
              c34z(iut,jut).e(m)=(v3_4z(m).a(iut,jut)+rmb*v3_4z(m).b(iut
     &          ,jut)+(-rmb)*v3_4z(m).c(iut,jut)+rmb*(-rmb)*v3_4z(m).
     &          d(iu
     &          t,jut))/cdz
            ENDDO
          ENDDO
        END DO
        DO i1=1,2
          DO i2=1,2
* pk0 -- p=c34f(i1,i2).e
            c34f(i1,i2).ek0=c34f(i1,i2).e(0)-c34f(i1,i2).e(1)
          END DO
        END DO
* aggiungo al propagatore della zeta pezzo prop. a k(mu)*k(nu)
        DO i1=1,2
          DO i2=1,2
* p.q -- p.q=caux,p=c34z(i1,i2).e,q=p34
            caux=c34z(i1,i2).e(0)*p34(0)-c34z(i1,i2).e(1)*p34(1)-c34z(
     &        i1,i2).e(2)*p34(2)-c34z(i1,i2).e(3)*p34(3)
            DO m=0,3
              c34z(i1,i2).e(m)=c34z(i1,i2).e(m)-caux*p34(m)/rmz2
            END DO
          END DO
        END DO
        DO i1=1,2
          DO i2=1,2
* pk0 -- p=c34z(i1,i2).e
            c34z(i1,i2).ek0=c34z(i1,i2).e(0)-c34z(i1,i2).e(1)
          END DO
        END DO
      ENDIF !(c34f e c34z)
* quqd -- p=p5,q=p6
      quqd=p5(0)*p6(0)-p5(1)*p6(1)-p5(2)*p6(2)-p5(3)*p6(3)
      cdz=-(2.d0*quqd*czipr-rmz2+ccz)
      df=-2.d0*quqd
      ccr=z5r/cdz
      ccl=z5l/cdz
* T10 -- qu=p5,qd=p6,v=0,a=c56z(&).e(0),cr=ccr,cl=ccl,nsum=0
      eps_0=-p5(2)*p6(3)+p6(2)*p5(3)
      ceps_0=eps_0*cim
      auxa=-quqd+p5k0*p6(0)+p6k0*p5(0)
      c56z(1).e(0)=ccr*(auxa+ceps_0)
      c56z(2).e(0)=ccl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=1,a=c56z(&).e(1),cr=ccr,cl=ccl,nsum=0
      auxa=-quqd+p5k0*p6(1)+p6k0*p5(1)
      c56z(1).e(1)=ccr*(auxa+ceps_0)
      c56z(2).e(1)=ccl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=2,a=c56z(&).e(2),cr=ccr,cl=ccl,nsum=0
      eps_0=-p5k0*p6(3)+p6k0*p5(3)
      ceps_0=eps_0*cim
      auxa=p5k0*p6(2)+p6k0*p5(2)
      c56z(1).e(2)=ccr*(auxa+ceps_0)
      c56z(2).e(2)=ccl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=3,a=c56z(&).e(3),cr=ccr,cl=ccl,nsum=0
      eps_0=p5k0*p6(2)-p6k0*p5(2)
      ceps_0=eps_0*cim
      auxa=p5k0*p6(3)+p6k0*p5(3)
      c56z(1).e(3)=ccr*(auxa+ceps_0)
      c56z(2).e(3)=ccl*(auxa-ceps_0)
      DO i=1,2
* pk0 -- p=c56z(i).e
        c56z(i).ek0=c56z(i).e(0)-c56z(i).e(1)
      END DO
      IF (imix.EQ.-1.or.imix.eq.-2) then
        rcr=f5r/df
        rcl=f5l/df
* T10 -- qu=p5,qd=p6,v=0,a=c56f(&).e(0),cr=rcr,cl=rcl,nsum=0
        eps_0=-p5(2)*p6(3)+p6(2)*p5(3)
        ceps_0=eps_0*cim
        auxa=-quqd+p5k0*p6(0)+p6k0*p5(0)
        c56f(1).e(0)=rcr*(auxa+ceps_0)
        c56f(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=1,a=c56f(&).e(1),cr=rcr,cl=rcl,nsum=0
        auxa=-quqd+p5k0*p6(1)+p6k0*p5(1)
        c56f(1).e(1)=rcr*(auxa+ceps_0)
        c56f(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=2,a=c56f(&).e(2),cr=rcr,cl=rcl,nsum=0
        eps_0=-p5k0*p6(3)+p6k0*p5(3)
        ceps_0=eps_0*cim
        auxa=p5k0*p6(2)+p6k0*p5(2)
        c56f(1).e(2)=rcr*(auxa+ceps_0)
        c56f(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=3,a=c56f(&).e(3),cr=rcr,cl=rcl,nsum=0
        eps_0=p5k0*p6(2)-p6k0*p5(2)
        ceps_0=eps_0*cim
        auxa=p5k0*p6(3)+p6k0*p5(3)
        c56f(1).e(3)=rcr*(auxa+ceps_0)
        c56f(2).e(3)=rcl*(auxa-ceps_0)
        DO i=1,2
* pk0 -- p=c56f(i).e
          c56f(i).ek0=c56f(i).e(0)-c56f(i).e(1)
        END DO
*****attaccamento di  c12f(2) a 3 (b)
* quqd -- p=p3,q=p123
        quqd=p3(0)*p123(0)-p3(1)*p123(1)-p3(2)*p123(2)-p3(3)*p123(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p123,v=c12f(i).e,a=u3_12f(i).a,b=u3_12f(i).b,c=u3_12f(i).c,
* d=u3_12f(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c12f(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &      2f(i).e(2)*p123(3)-p123(2)*c12f(i).e(3))-p123k0*(c12f(i).
     &      e(2)*p3(3)-p3(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p3k0+p3(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12f(i).e(3)*p123k0+p123(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p3(0)-c12f(i).e(1)*p3(1)-c12f(i).e(2)*p3
     &      (2)-c12f(i).e(3)*p3(3)
          cvqd=c12f(i).e(0)*p123(0)-c12f(i).e(1)*p123(1)-c12f(i).e(2
     &      )*p123(2)-c12f(i).e(3)*p123(3)
          cauxa=-c12f(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
          cauxb=-c12f(i).ek0*p123(2)+p123k0*c12f(i).e(2)
          cauxc=+c12f(i).ek0*p3(2)-p3k0*c12f(i).e(2)
          u3_12f(i).a(1,1)=fqdr*(cauxa+ceps_0)
          u3_12f(i).a(2,2)=fqdl*(cauxa-ceps_0)
          u3_12f(i).b(1,2)=fqdl*(cauxb-ceps_2)
          u3_12f(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          u3_12f(i).c(1,2)=fqdr*(cauxc+ceps_1)
          u3_12f(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          u3_12f(i).d(1,1)=fqdl*c12f(i).ek0
          u3_12f(i).d(2,2)=fqdr*c12f(i).ek0
        END DO
*****attaccamento di  c12f(2) a 4 (bbar)
* quqd -- p=p356,q=p4
        quqd=p356(0)*p4(0)-p356(1)*p4(1)-p356(2)*p4(2)-p356(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p356,qd=p4,v=c12f(i).e,a=d4_12f(i).a,b=d4_12f(i).b,c=d4_12f(i).c,
* d=d4_12f(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c12f(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &      c12f(i).e(2)*p4(3)-p4(2)*c12f(i).e(3))-p4k0*(c12f(i).e(2)
     &      *p356(3)-p356(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p356k0+p356(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12f(i).e(3)*p4k0+p4(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p356(0)-c12f(i).e(1)*p356(1)-c12f(i).e(2
     &      )*p356(2)-c12f(i).e(3)*p356(3)
          cvqd=c12f(i).e(0)*p4(0)-c12f(i).e(1)*p4(1)-c12f(i).e(2)*p4
     &      (2)-c12f(i).e(3)*p4(3)
          cauxa=-c12f(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
          cauxb=-c12f(i).ek0*p4(2)+p4k0*c12f(i).e(2)
          cauxc=+c12f(i).ek0*p356(2)-p356k0*c12f(i).e(2)
          d4_12f(i).a(1,1)=fqdr*(cauxa+ceps_0)
          d4_12f(i).a(2,2)=fqdl*(cauxa-ceps_0)
          d4_12f(i).b(1,2)=fqdl*(cauxb-ceps_2)
          d4_12f(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          d4_12f(i).c(1,2)=fqdr*(cauxc+ceps_1)
          d4_12f(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          d4_12f(i).d(1,1)=fqdl*c12f(i).ek0
          d4_12f(i).d(2,2)=fqdr*c12f(i).ek0
        END DO
*****attaccamento di  c34f(2,2) a 1 (e+)
* quqd -- p=p1,q=p134
        quqd=p1(0)*p134(0)-p1(1)*p134(1)-p1(2)*p134(2)-p1(3)*p134(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p1,qd=p134,v=c34f(i1,i2).e,a=l1_34f(i1,i2).a,c=l1_34f(i1,i2).c,
* cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0
     &        *(c34f(i1,i2).e(2)*p134(3)-p134(2)*c34f(i1,i2).e(3))-p134
     &        k0*(c34f(i1,i2).e(2)*p1(3)-p1(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i1,i2).e(3)*p1k0+p1(3)*c34f(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i1,i2).e(0)*p1(0)-c34f(i1,i2).e(1)*p1(1)-c34f(i1
     &        ,i2).e(2)*p1(2)-c34f(i1,i2).e(3)*p1(3)
            cvqd=c34f(i1,i2).e(0)*p134(0)-c34f(i1,i2).e(1)*p134(1)-c34
     &        f(i1,i2).e(2)*p134(2)-c34f(i1,i2).e(3)*p134(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34f(i1,i2).ek0*p1(2)-p1k0*c34f(i1,i2).e(2)
            l1_34f(i1,i2).a(1)=fer*(cauxa+ceps_0)
            l1_34f(i1,i2).a(2)=fel*(cauxa-ceps_0)
            l1_34f(i1,i2).c(1)=fer*(cauxc+ceps_1)
            l1_34f(i1,i2).c(2)=fel*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c34f(2,2) a 2 (e-)
* quqd -- p=p156,q=p2
        quqd=p156(0)*p2(0)-p156(1)*p2(1)-p156(2)*p2(2)-p156(3)*p2(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p156,qd=p2,v=c34f(i1,i2).e,a=r2_34f(i1,i2).a,b=r2_34f(i1,i2).b,
* cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156
     &        k0*(c34f(i1,i2).e(2)*p2(3)-p2(2)*c34f(i1,i2).e(3))-p2k0*(
     &        c34f(i1,i2).e(2)*p156(3)-p156(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i1,i2).e(3)*p2k0+p2(3)*c34f(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i1,i2).e(0)*p156(0)-c34f(i1,i2).e(1)*p156(1)-c34
     &        f(i1,i2).e(2)*p156(2)-c34f(i1,i2).e(3)*p156(3)
            cvqd=c34f(i1,i2).e(0)*p2(0)-c34f(i1,i2).e(1)*p2(1)-c34f(i1
     &        ,i2).e(2)*p2(2)-c34f(i1,i2).e(3)*p2(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34f(i1,i2).ek0*p2(2)+p2k0*c34f(i1,i2).e(2)
            r2_34f(i1,i2).a(1)=fer*(cauxa+ceps_0)
            r2_34f(i1,i2).a(2)=fel*(cauxa-ceps_0)
            r2_34f(i1,i2).b(1)=fel*(cauxb-ceps_2)
            r2_34f(i1,i2).b(2)=fer*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c12z(2) a 3 (b)
* quqd -- p=p3,q=p123
        quqd=p3(0)*p123(0)-p3(1)*p123(1)-p3(2)*p123(2)-p3(3)*p123(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p123,v=c12z(i).e,a=u3_12z(i).a,b=u3_12z(i).b,c=u3_12z(i).c,
* d=u3_12z(i).d,cr=zqdr,cl=zqdl,nsum=0
          ceps_0=-c12z(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &      2z(i).e(2)*p123(3)-p123(2)*c12z(i).e(3))-p123k0*(c12z(i).
     &      e(2)*p3(3)-p3(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p3k0+p3(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12z(i).e(3)*p123k0+p123(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p3(0)-c12z(i).e(1)*p3(1)-c12z(i).e(2)*p3
     &      (2)-c12z(i).e(3)*p3(3)
          cvqd=c12z(i).e(0)*p123(0)-c12z(i).e(1)*p123(1)-c12z(i).e(2
     &      )*p123(2)-c12z(i).e(3)*p123(3)
          cauxa=-c12z(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
          cauxb=-c12z(i).ek0*p123(2)+p123k0*c12z(i).e(2)
          cauxc=+c12z(i).ek0*p3(2)-p3k0*c12z(i).e(2)
          u3_12z(i).a(1,1)=zqdr*(cauxa+ceps_0)
          u3_12z(i).a(2,2)=zqdl*(cauxa-ceps_0)
          u3_12z(i).b(1,2)=zqdl*(cauxb-ceps_2)
          u3_12z(i).b(2,1)=zqdr*(-cauxb-ceps_2)
          u3_12z(i).c(1,2)=zqdr*(cauxc+ceps_1)
          u3_12z(i).c(2,1)=zqdl*(-cauxc+ceps_1)
          u3_12z(i).d(1,1)=zqdl*c12z(i).ek0
          u3_12z(i).d(2,2)=zqdr*c12z(i).ek0
        END DO
*****attaccamento di  c12z(2) a 4 (bbar)
* quqd -- p=p356,q=p4
        quqd=p356(0)*p4(0)-p356(1)*p4(1)-p356(2)*p4(2)-p356(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p356,qd=p4,v=c12z(i).e,a=d4_12z(i).a,b=d4_12z(i).b,c=d4_12z(i).c,
* d=d4_12z(i).d,cr=zqdr,cl=zqdl,nsum=0
          ceps_0=-c12z(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &      c12z(i).e(2)*p4(3)-p4(2)*c12z(i).e(3))-p4k0*(c12z(i).e(2)
     &      *p356(3)-p356(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p356k0+p356(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12z(i).e(3)*p4k0+p4(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p356(0)-c12z(i).e(1)*p356(1)-c12z(i).e(2
     &      )*p356(2)-c12z(i).e(3)*p356(3)
          cvqd=c12z(i).e(0)*p4(0)-c12z(i).e(1)*p4(1)-c12z(i).e(2)*p4
     &      (2)-c12z(i).e(3)*p4(3)
          cauxa=-c12z(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
          cauxb=-c12z(i).ek0*p4(2)+p4k0*c12z(i).e(2)
          cauxc=+c12z(i).ek0*p356(2)-p356k0*c12z(i).e(2)
          d4_12z(i).a(1,1)=zqdr*(cauxa+ceps_0)
          d4_12z(i).a(2,2)=zqdl*(cauxa-ceps_0)
          d4_12z(i).b(1,2)=zqdl*(cauxb-ceps_2)
          d4_12z(i).b(2,1)=zqdr*(-cauxb-ceps_2)
          d4_12z(i).c(1,2)=zqdr*(cauxc+ceps_1)
          d4_12z(i).c(2,1)=zqdl*(-cauxc+ceps_1)
          d4_12z(i).d(1,1)=zqdl*c12z(i).ek0
          d4_12z(i).d(2,2)=zqdr*c12z(i).ek0
        END DO
*****attaccamento di  c34z(2,2) a 1 (e+)
* quqd -- p=p1,q=p134
        quqd=p1(0)*p134(0)-p1(1)*p134(1)-p1(2)*p134(2)-p1(3)*p134(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p1,qd=p134,v=c34z(i1,i2).e,a=l1_34z(i1,i2).a,c=l1_34z(i1,i2).c,
* cr=zer,cl=zel,nsum=0
            ceps_0=-c34z(i1,i2).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0
     &        *(c34z(i1,i2).e(2)*p134(3)-p134(2)*c34z(i1,i2).e(3))-p134
     &        k0*(c34z(i1,i2).e(2)*p1(3)-p1(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i1,i2).e(3)*p1k0+p1(3)*c34z(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i1,i2).e(0)*p1(0)-c34z(i1,i2).e(1)*p1(1)-c34z(i1
     &        ,i2).e(2)*p1(2)-c34z(i1,i2).e(3)*p1(3)
            cvqd=c34z(i1,i2).e(0)*p134(0)-c34z(i1,i2).e(1)*p134(1)-c34
     &        z(i1,i2).e(2)*p134(2)-c34z(i1,i2).e(3)*p134(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34z(i1,i2).ek0*p1(2)-p1k0*c34z(i1,i2).e(2)
            l1_34z(i1,i2).a(1)=zer*(cauxa+ceps_0)
            l1_34z(i1,i2).a(2)=zel*(cauxa-ceps_0)
            l1_34z(i1,i2).c(1)=zer*(cauxc+ceps_1)
            l1_34z(i1,i2).c(2)=zel*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c34z(2,2) a 2 (e-)
* quqd -- p=p156,q=p2
        quqd=p156(0)*p2(0)-p156(1)*p2(1)-p156(2)*p2(2)-p156(3)*p2(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p156,qd=p2,v=c34z(i1,i2).e,a=r2_34z(i1,i2).a,b=r2_34z(i1,i2).b,
* cr=zer,cl=zel,nsum=0
            ceps_0=-c34z(i1,i2).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156
     &        k0*(c34z(i1,i2).e(2)*p2(3)-p2(2)*c34z(i1,i2).e(3))-p2k0*(
     &        c34z(i1,i2).e(2)*p156(3)-p156(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i1,i2).e(3)*p2k0+p2(3)*c34z(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i1,i2).e(0)*p156(0)-c34z(i1,i2).e(1)*p156(1)-c34
     &        z(i1,i2).e(2)*p156(2)-c34z(i1,i2).e(3)*p156(3)
            cvqd=c34z(i1,i2).e(0)*p2(0)-c34z(i1,i2).e(1)*p2(1)-c34z(i1
     &        ,i2).e(2)*p2(2)-c34z(i1,i2).e(3)*p2(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34z(i1,i2).ek0*p2(2)+p2k0*c34z(i1,i2).e(2)
            r2_34z(i1,i2).a(1)=zer*(cauxa+ceps_0)
            r2_34z(i1,i2).a(2)=zel*(cauxa-ceps_0)
            r2_34z(i1,i2).b(1)=zel*(cauxb-ceps_2)
            r2_34z(i1,i2).b(2)=zer*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c56z a 3 (b)
* quqd -- p=p3,q=p356
        quqd=p3(0)*p356(0)-p3(1)*p356(1)-p3(2)*p356(2)-p3(3)*p356(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p356,v=c56z(i).e,a=u3_56z(i).a,b=u3_56z(i).b,c=u3_56z(i).c,
* d=u3_56z(i).d,cr=zqdr,cl=zqdl,nsum=0
          ceps_0=-c56z(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &      6z(i).e(2)*p356(3)-p356(2)*c56z(i).e(3))-p356k0*(c56z(i).
     &      e(2)*p3(3)-p3(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p3k0+p3(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56z(i).e(3)*p356k0+p356(3)*c56z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i).e(0)*p3(0)-c56z(i).e(1)*p3(1)-c56z(i).e(2)*p3
     &      (2)-c56z(i).e(3)*p3(3)
          cvqd=c56z(i).e(0)*p356(0)-c56z(i).e(1)*p356(1)-c56z(i).e(2
     &      )*p356(2)-c56z(i).e(3)*p356(3)
          cauxa=-c56z(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
          cauxb=-c56z(i).ek0*p356(2)+p356k0*c56z(i).e(2)
          cauxc=+c56z(i).ek0*p3(2)-p3k0*c56z(i).e(2)
          u3_56z(i).a(1,1)=zqdr*(cauxa+ceps_0)
          u3_56z(i).a(2,2)=zqdl*(cauxa-ceps_0)
          u3_56z(i).b(1,2)=zqdl*(cauxb-ceps_2)
          u3_56z(i).b(2,1)=zqdr*(-cauxb-ceps_2)
          u3_56z(i).c(1,2)=zqdr*(cauxc+ceps_1)
          u3_56z(i).c(2,1)=zqdl*(-cauxc+ceps_1)
          u3_56z(i).d(1,1)=zqdl*c56z(i).ek0
          u3_56z(i).d(2,2)=zqdr*c56z(i).ek0
        END DO
*****attaccamento di  c56f a 3 (b)
* quqd -- p=p3,q=p356
        quqd=p3(0)*p356(0)-p3(1)*p356(1)-p3(2)*p356(2)-p3(3)*p356(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p356,v=c56f(i).e,a=u3_56f(i).a,b=u3_56f(i).b,c=u3_56f(i).c,
* d=u3_56f(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c56f(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &      6f(i).e(2)*p356(3)-p356(2)*c56f(i).e(3))-p356k0*(c56f(i).
     &      e(2)*p3(3)-p3(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p3k0+p3(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56f(i).e(3)*p356k0+p356(3)*c56f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i).e(0)*p3(0)-c56f(i).e(1)*p3(1)-c56f(i).e(2)*p3
     &      (2)-c56f(i).e(3)*p3(3)
          cvqd=c56f(i).e(0)*p356(0)-c56f(i).e(1)*p356(1)-c56f(i).e(2
     &      )*p356(2)-c56f(i).e(3)*p356(3)
          cauxa=-c56f(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
          cauxb=-c56f(i).ek0*p356(2)+p356k0*c56f(i).e(2)
          cauxc=+c56f(i).ek0*p3(2)-p3k0*c56f(i).e(2)
          u3_56f(i).a(1,1)=fqdr*(cauxa+ceps_0)
          u3_56f(i).a(2,2)=fqdl*(cauxa-ceps_0)
          u3_56f(i).b(1,2)=fqdl*(cauxb-ceps_2)
          u3_56f(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          u3_56f(i).c(1,2)=fqdr*(cauxc+ceps_1)
          u3_56f(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          u3_56f(i).d(1,1)=fqdl*c56f(i).ek0
          u3_56f(i).d(2,2)=fqdr*c56f(i).ek0
        END DO
*****attaccamento di  c56z a 4 (bbar)
* quqd -- p=p123,q=p4
        quqd=p123(0)*p4(0)-p123(1)*p4(1)-p123(2)*p4(2)-p123(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p123,qd=p4,v=c56z(i).e,a=d4_56z(i).a,b=d4_56z(i).b,c=d4_56z(i).c,
* d=d4_56z(i).d,cr=zqdr,cl=zqdl,nsum=0
          ceps_0=-c56z(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &      c56z(i).e(2)*p4(3)-p4(2)*c56z(i).e(3))-p4k0*(c56z(i).e(2)
     &      *p123(3)-p123(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p123k0+p123(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56z(i).e(3)*p4k0+p4(3)*c56z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i).e(0)*p123(0)-c56z(i).e(1)*p123(1)-c56z(i).e(2
     &      )*p123(2)-c56z(i).e(3)*p123(3)
          cvqd=c56z(i).e(0)*p4(0)-c56z(i).e(1)*p4(1)-c56z(i).e(2)*p4
     &      (2)-c56z(i).e(3)*p4(3)
          cauxa=-c56z(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
          cauxb=-c56z(i).ek0*p4(2)+p4k0*c56z(i).e(2)
          cauxc=+c56z(i).ek0*p123(2)-p123k0*c56z(i).e(2)
          d4_56z(i).a(1,1)=zqdr*(cauxa+ceps_0)
          d4_56z(i).a(2,2)=zqdl*(cauxa-ceps_0)
          d4_56z(i).b(1,2)=zqdl*(cauxb-ceps_2)
          d4_56z(i).b(2,1)=zqdr*(-cauxb-ceps_2)
          d4_56z(i).c(1,2)=zqdr*(cauxc+ceps_1)
          d4_56z(i).c(2,1)=zqdl*(-cauxc+ceps_1)
          d4_56z(i).d(1,1)=zqdl*c56z(i).ek0
          d4_56z(i).d(2,2)=zqdr*c56z(i).ek0
        END DO
*****attaccamento di  c56f a 4 (bbar)
* quqd -- p=p123,q=p4
        quqd=p123(0)*p4(0)-p123(1)*p4(1)-p123(2)*p4(2)-p123(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p123,qd=p4,v=c56f(i).e,a=d4_56f(i).a,b=d4_56f(i).b,c=d4_56f(i).c,
* d=d4_56f(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c56f(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &      c56f(i).e(2)*p4(3)-p4(2)*c56f(i).e(3))-p4k0*(c56f(i).e(2)
     &      *p123(3)-p123(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p123k0+p123(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56f(i).e(3)*p4k0+p4(3)*c56f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i).e(0)*p123(0)-c56f(i).e(1)*p123(1)-c56f(i).e(2
     &      )*p123(2)-c56f(i).e(3)*p123(3)
          cvqd=c56f(i).e(0)*p4(0)-c56f(i).e(1)*p4(1)-c56f(i).e(2)*p4
     &      (2)-c56f(i).e(3)*p4(3)
          cauxa=-c56f(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
          cauxb=-c56f(i).ek0*p4(2)+p4k0*c56f(i).e(2)
          cauxc=+c56f(i).ek0*p123(2)-p123k0*c56f(i).e(2)
          d4_56f(i).a(1,1)=fqdr*(cauxa+ceps_0)
          d4_56f(i).a(2,2)=fqdl*(cauxa-ceps_0)
          d4_56f(i).b(1,2)=fqdl*(cauxb-ceps_2)
          d4_56f(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          d4_56f(i).c(1,2)=fqdr*(cauxc+ceps_1)
          d4_56f(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          d4_56f(i).d(1,1)=fqdl*c56f(i).ek0
          d4_56f(i).d(2,2)=fqdr*c56f(i).ek0
        END DO
*****attaccamento di  c12z(2) a 5 (v)
* quqd -- p=p5,q=p125
        quqd=p5(0)*p125(0)-p5(1)*p125(1)-p5(2)*p125(2)-p5(3)*p125(
     &    3)
        DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12z(i).e,a=l5_12z(i).a,c=l5_12z(i).c,cr=zer,cl=ze
* l,nsum=0
          ceps_0=-c12z(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &      2z(i).e(2)*p125(3)-p125(2)*c12z(i).e(3))-p125k0*(c12z(i).
     &      e(2)*p5(3)-p5(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p5k0+p5(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c12z(i).e(0)*p5(0)-c12z(i).e(1)*p5(1)-c12z(i).e(2)*p5
     &      (2)-c12z(i).e(3)*p5(3)
          cvqd=c12z(i).e(0)*p125(0)-c12z(i).e(1)*p125(1)-c12z(i).e(2
     &      )*p125(2)-c12z(i).e(3)*p125(3)
          cauxa=-c12z(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
          cauxc=+c12z(i).ek0*p5(2)-p5k0*c12z(i).e(2)
          l5_12z(i).a(1)=z5r*(cauxa+ceps_0)
          l5_12z(i).a(2)=z5l*(cauxa-ceps_0)
          l5_12z(i).c(1)=z5r*(cauxc+ceps_1)
          l5_12z(i).c(2)=z5l*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c12f(2) a 5 (v)
* quqd -- p=p5,q=p125
        quqd=p5(0)*p125(0)-p5(1)*p125(1)-p5(2)*p125(2)-p5(3)*p125(
     &    3)
        DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12f(i).e,a=l5_12f(i).a,c=l5_12f(i).c,cr=fer,cl=fe
* l,nsum=0
          ceps_0=-c12f(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &      2f(i).e(2)*p125(3)-p125(2)*c12f(i).e(3))-p125k0*(c12f(i).
     &      e(2)*p5(3)-p5(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p5k0+p5(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c12f(i).e(0)*p5(0)-c12f(i).e(1)*p5(1)-c12f(i).e(2)*p5
     &      (2)-c12f(i).e(3)*p5(3)
          cvqd=c12f(i).e(0)*p125(0)-c12f(i).e(1)*p125(1)-c12f(i).e(2
     &      )*p125(2)-c12f(i).e(3)*p125(3)
          cauxa=-c12f(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
          cauxc=+c12f(i).ek0*p5(2)-p5k0*c12f(i).e(2)
          l5_12f(i).a(1)=f5r*(cauxa+ceps_0)
          l5_12f(i).a(2)=f5l*(cauxa-ceps_0)
          l5_12f(i).c(1)=f5r*(cauxc+ceps_1)
          l5_12f(i).c(2)=f5l*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c34z(2,2) a 5 (v)
* quqd -- p=p5,q=p345
        quqd=p5(0)*p345(0)-p5(1)*p345(1)-p5(2)*p345(2)-p5(3)*p345(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p5,qd=p345,v=c34z(i1,i2).e,a=l5_34z(i1,i2).a,c=l5_34z(i1,i2).c,
* cr=zer,cl=zel,nsum=0
            ceps_0=-c34z(i1,i2).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0
     &        *(c34z(i1,i2).e(2)*p345(3)-p345(2)*c34z(i1,i2).e(3))-p345
     &        k0*(c34z(i1,i2).e(2)*p5(3)-p5(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i1,i2).e(3)*p5k0+p5(3)*c34z(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i1,i2).e(0)*p5(0)-c34z(i1,i2).e(1)*p5(1)-c34z(i1
     &        ,i2).e(2)*p5(2)-c34z(i1,i2).e(3)*p5(3)
            cvqd=c34z(i1,i2).e(0)*p345(0)-c34z(i1,i2).e(1)*p345(1)-c34
     &        z(i1,i2).e(2)*p345(2)-c34z(i1,i2).e(3)*p345(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34z(i1,i2).ek0*p5(2)-p5k0*c34z(i1,i2).e(2)
            l5_34z(i1,i2).a(1)=z5r*(cauxa+ceps_0)
            l5_34z(i1,i2).a(2)=z5l*(cauxa-ceps_0)
            l5_34z(i1,i2).c(1)=z5r*(cauxc+ceps_1)
            l5_34z(i1,i2).c(2)=z5l*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c34f(2,2) a 5 (v)
* quqd -- p=p5,q=p345
        quqd=p5(0)*p345(0)-p5(1)*p345(1)-p5(2)*p345(2)-p5(3)*p345(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p5,qd=p345,v=c34f(i1,i2).e,a=l5_34f(i1,i2).a,c=l5_34f(i1,i2).c,
* cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0
     &        *(c34f(i1,i2).e(2)*p345(3)-p345(2)*c34f(i1,i2).e(3))-p345
     &        k0*(c34f(i1,i2).e(2)*p5(3)-p5(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i1,i2).e(3)*p5k0+p5(3)*c34f(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i1,i2).e(0)*p5(0)-c34f(i1,i2).e(1)*p5(1)-c34f(i1
     &        ,i2).e(2)*p5(2)-c34f(i1,i2).e(3)*p5(3)
            cvqd=c34f(i1,i2).e(0)*p345(0)-c34f(i1,i2).e(1)*p345(1)-c34
     &        f(i1,i2).e(2)*p345(2)-c34f(i1,i2).e(3)*p345(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34f(i1,i2).ek0*p5(2)-p5k0*c34f(i1,i2).e(2)
            l5_34f(i1,i2).a(1)=f5r*(cauxa+ceps_0)
            l5_34f(i1,i2).a(2)=f5l*(cauxa-ceps_0)
            l5_34f(i1,i2).c(1)=f5r*(cauxc+ceps_1)
            l5_34f(i1,i2).c(2)=f5l*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c56z a 1 (e+)
* quqd -- p=p1,q=p156
        quqd=p1(0)*p156(0)-p1(1)*p156(1)-p1(2)*p156(2)-p1(3)*p156(
     &    3)
        DO i=1,2
* TL0 -- qu=p1,qd=p156,v=c56z(i).e,a=l1_56z(i).a,c=l1_56z(i).c,cr=zer,cl=ze
* l,nsum=0
          ceps_0=-c56z(i).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c5
     &      6z(i).e(2)*p156(3)-p156(2)*c56z(i).e(3))-p156k0*(c56z(i).
     &      e(2)*p1(3)-p1(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p1k0+p1(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c56z(i).e(0)*p1(0)-c56z(i).e(1)*p1(1)-c56z(i).e(2)*p1
     &      (2)-c56z(i).e(3)*p1(3)
          cvqd=c56z(i).e(0)*p156(0)-c56z(i).e(1)*p156(1)-c56z(i).e(2
     &      )*p156(2)-c56z(i).e(3)*p156(3)
          cauxa=-c56z(i).ek0*quqd+p1k0*cvqd+p156k0*cvqu
          cauxc=+c56z(i).ek0*p1(2)-p1k0*c56z(i).e(2)
          l1_56z(i).a(1)=zer*(cauxa+ceps_0)
          l1_56z(i).a(2)=zel*(cauxa-ceps_0)
          l1_56z(i).c(1)=zer*(cauxc+ceps_1)
          l1_56z(i).c(2)=zel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c56f a 1 (e+)
* quqd -- p=p1,q=p156
        quqd=p1(0)*p156(0)-p1(1)*p156(1)-p1(2)*p156(2)-p1(3)*p156(
     &    3)
        DO i=1,2
* TL0 -- qu=p1,qd=p156,v=c56f(i).e,a=l1_56f(i).a,c=l1_56f(i).c,cr=fer,cl=fe
* l,nsum=0
          ceps_0=-c56f(i).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c5
     &      6f(i).e(2)*p156(3)-p156(2)*c56f(i).e(3))-p156k0*(c56f(i).
     &      e(2)*p1(3)-p1(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p1k0+p1(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c56f(i).e(0)*p1(0)-c56f(i).e(1)*p1(1)-c56f(i).e(2)*p1
     &      (2)-c56f(i).e(3)*p1(3)
          cvqd=c56f(i).e(0)*p156(0)-c56f(i).e(1)*p156(1)-c56f(i).e(2
     &      )*p156(2)-c56f(i).e(3)*p156(3)
          cauxa=-c56f(i).ek0*quqd+p1k0*cvqd+p156k0*cvqu
          cauxc=+c56f(i).ek0*p1(2)-p1k0*c56f(i).e(2)
          l1_56f(i).a(1)=fer*(cauxa+ceps_0)
          l1_56f(i).a(2)=fel*(cauxa-ceps_0)
          l1_56f(i).c(1)=fer*(cauxc+ceps_1)
          l1_56f(i).c(2)=fel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c12z(2) a 6 (vbar)
* quqd -- p=p345,q=p6
        quqd=p345(0)*p6(0)-p345(1)*p6(1)-p345(2)*p6(2)-p345(3)*p6(
     &    3)
        DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12z(i).e,a=r6_12z(i).a,b=r6_12z(i).b,cr=zer,cl=ze
* l,nsum=0
          ceps_0=-c12z(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &      c12z(i).e(2)*p6(3)-p6(2)*c12z(i).e(3))-p6k0*(c12z(i).e(2)
     &      *p345(3)-p345(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c12z(i).e(3)*p6k0+p6(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p345(0)-c12z(i).e(1)*p345(1)-c12z(i).e(2
     &      )*p345(2)-c12z(i).e(3)*p345(3)
          cvqd=c12z(i).e(0)*p6(0)-c12z(i).e(1)*p6(1)-c12z(i).e(2)*p6
     &      (2)-c12z(i).e(3)*p6(3)
          cauxa=-c12z(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
          cauxb=-c12z(i).ek0*p6(2)+p6k0*c12z(i).e(2)
          r6_12z(i).a(1)=z6r*(cauxa+ceps_0)
          r6_12z(i).a(2)=z6l*(cauxa-ceps_0)
          r6_12z(i).b(1)=z6l*(cauxb-ceps_2)
          r6_12z(i).b(2)=z6r*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c12f(2) a 6 (vbar)
* quqd -- p=p345,q=p6
        quqd=p345(0)*p6(0)-p345(1)*p6(1)-p345(2)*p6(2)-p345(3)*p6(
     &    3)
        DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12f(i).e,a=r6_12f(i).a,b=r6_12f(i).b,cr=fer,cl=fe
* l,nsum=0
          ceps_0=-c12f(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &      c12f(i).e(2)*p6(3)-p6(2)*c12f(i).e(3))-p6k0*(c12f(i).e(2)
     &      *p345(3)-p345(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c12f(i).e(3)*p6k0+p6(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p345(0)-c12f(i).e(1)*p345(1)-c12f(i).e(2
     &      )*p345(2)-c12f(i).e(3)*p345(3)
          cvqd=c12f(i).e(0)*p6(0)-c12f(i).e(1)*p6(1)-c12f(i).e(2)*p6
     &      (2)-c12f(i).e(3)*p6(3)
          cauxa=-c12f(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
          cauxb=-c12f(i).ek0*p6(2)+p6k0*c12f(i).e(2)
          r6_12f(i).a(1)=f6r*(cauxa+ceps_0)
          r6_12f(i).a(2)=f6l*(cauxa-ceps_0)
          r6_12f(i).b(1)=f6l*(cauxb-ceps_2)
          r6_12f(i).b(2)=f6r*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c34z(2,2) a 6 (vbar)
* quqd -- p=p125,q=p6
        quqd=p125(0)*p6(0)-p125(1)*p6(1)-p125(2)*p6(2)-p125(3)*p6(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p125,qd=p6,v=c34z(i1,i2).e,a=r6_34z(i1,i2).a,b=r6_34z(i1,i2).b,
* cr=zer,cl=zel,nsum=0
            ceps_0=-c34z(i1,i2).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125
     &        k0*(c34z(i1,i2).e(2)*p6(3)-p6(2)*c34z(i1,i2).e(3))-p6k0*(
     &        c34z(i1,i2).e(2)*p125(3)-p125(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i1,i2).e(3)*p6k0+p6(3)*c34z(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i1,i2).e(0)*p125(0)-c34z(i1,i2).e(1)*p125(1)-c34
     &        z(i1,i2).e(2)*p125(2)-c34z(i1,i2).e(3)*p125(3)
            cvqd=c34z(i1,i2).e(0)*p6(0)-c34z(i1,i2).e(1)*p6(1)-c34z(i1
     &        ,i2).e(2)*p6(2)-c34z(i1,i2).e(3)*p6(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34z(i1,i2).ek0*p6(2)+p6k0*c34z(i1,i2).e(2)
            r6_34z(i1,i2).a(1)=z6r*(cauxa+ceps_0)
            r6_34z(i1,i2).a(2)=z6l*(cauxa-ceps_0)
            r6_34z(i1,i2).b(1)=z6l*(cauxb-ceps_2)
            r6_34z(i1,i2).b(2)=z6r*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c34f(2,2) a 6 (vbar)
* quqd -- p=p125,q=p6
        quqd=p125(0)*p6(0)-p125(1)*p6(1)-p125(2)*p6(2)-p125(3)*p6(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p125,qd=p6,v=c34f(i1,i2).e,a=r6_34f(i1,i2).a,b=r6_34f(i1,i2).b,
* cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125
     &        k0*(c34f(i1,i2).e(2)*p6(3)-p6(2)*c34f(i1,i2).e(3))-p6k0*(
     &        c34f(i1,i2).e(2)*p125(3)-p125(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i1,i2).e(3)*p6k0+p6(3)*c34f(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i1,i2).e(0)*p125(0)-c34f(i1,i2).e(1)*p125(1)-c34
     &        f(i1,i2).e(2)*p125(2)-c34f(i1,i2).e(3)*p125(3)
            cvqd=c34f(i1,i2).e(0)*p6(0)-c34f(i1,i2).e(1)*p6(1)-c34f(i1
     &        ,i2).e(2)*p6(2)-c34f(i1,i2).e(3)*p6(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34f(i1,i2).ek0*p6(2)+p6k0*c34f(i1,i2).e(2)
            r6_34f(i1,i2).a(1)=f6r*(cauxa+ceps_0)
            r6_34f(i1,i2).a(2)=f6l*(cauxa-ceps_0)
            r6_34f(i1,i2).b(1)=f6l*(cauxb-ceps_2)
            r6_34f(i1,i2).b(2)=f6r*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c56z a 2 (e-)
* quqd -- p=p134,q=p2
        quqd=p134(0)*p2(0)-p134(1)*p2(1)-p134(2)*p2(2)-p134(3)*p2(
     &    3)
        DO i=1,2
* TR0 -- qu=p134,qd=p2,v=c56z(i).e,a=r2_56z(i).a,b=r2_56z(i).b,cr=zer,cl=ze
* l,nsum=0
          ceps_0=-c56z(i).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*(
     &      c56z(i).e(2)*p2(3)-p2(2)*c56z(i).e(3))-p2k0*(c56z(i).e(2)
     &      *p134(3)-p134(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c56z(i).e(3)*p2k0+p2(3)*c56z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i).e(0)*p134(0)-c56z(i).e(1)*p134(1)-c56z(i).e(2
     &      )*p134(2)-c56z(i).e(3)*p134(3)
          cvqd=c56z(i).e(0)*p2(0)-c56z(i).e(1)*p2(1)-c56z(i).e(2)*p2
     &      (2)-c56z(i).e(3)*p2(3)
          cauxa=-c56z(i).ek0*quqd+p134k0*cvqd+p2k0*cvqu
          cauxb=-c56z(i).ek0*p2(2)+p2k0*c56z(i).e(2)
          r2_56z(i).a(1)=zer*(cauxa+ceps_0)
          r2_56z(i).a(2)=zel*(cauxa-ceps_0)
          r2_56z(i).b(1)=zel*(cauxb-ceps_2)
          r2_56z(i).b(2)=zer*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c56f a 2 (e-)
* quqd -- p=p134,q=p2
        quqd=p134(0)*p2(0)-p134(1)*p2(1)-p134(2)*p2(2)-p134(3)*p2(
     &    3)
        DO i=1,2
* TR0 -- qu=p134,qd=p2,v=c56f(i).e,a=r2_56f(i).a,b=r2_56f(i).b,cr=fer,cl=fe
* l,nsum=0
          ceps_0=-c56f(i).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*(
     &      c56f(i).e(2)*p2(3)-p2(2)*c56f(i).e(3))-p2k0*(c56f(i).e(2)
     &      *p134(3)-p134(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c56f(i).e(3)*p2k0+p2(3)*c56f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i).e(0)*p134(0)-c56f(i).e(1)*p134(1)-c56f(i).e(2
     &      )*p134(2)-c56f(i).e(3)*p134(3)
          cvqd=c56f(i).e(0)*p2(0)-c56f(i).e(1)*p2(1)-c56f(i).e(2)*p2
     &      (2)-c56f(i).e(3)*p2(3)
          cauxa=-c56f(i).ek0*quqd+p134k0*cvqd+p2k0*cvqu
          cauxb=-c56f(i).ek0*p2(2)+p2k0*c56f(i).e(2)
          r2_56f(i).a(1)=fer*(cauxa+ceps_0)
          r2_56f(i).a(2)=fel*(cauxa-ceps_0)
          r2_56f(i).b(1)=fel*(cauxb-ceps_2)
          r2_56f(i).b(2)=fer*(-cauxb-ceps_2)
        END DO
**** Diagramma 4 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres4(i3,&,i1,i2),a1=l1_56f(i3).a,c1=l1_56f(i3).c,a2=r2_34f(i
* 1,i2).a,b2=r2_34f(i1,i2).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cres4(i3,1,i1,i2)=( l1_56f(i3).a(1)*r2_34f(i1,i2).a(1)+l1_
     &          56f(i3).c(1)*p156q*r2_34f(i1,i2).b(2) )/(p156q*p156k0)
              cres4(i3,2,i1,i2)=( l1_56f(i3).c(2)*p156q*r2_34f(i1,i2).b(
     &          1)+l1_56f(i3).a(2)*r2_34f(i1,i2).a(2) )/(p156q*p156k0)
            END DO
          END DO
        END DO
**** Diagramma 9 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres9(i3,&,i1,i2),a1=l1_34f(i1,i2).a,c1=l1_34f(i1,i2).c,a2=r2
* _56f(i3).a,b2=r2_56f(i3).b,prq=p134q,den=(p134q*p134k0),nsum=0
              cres9(i3,1,i1,i2)=( l1_34f(i1,i2).a(1)*r2_56f(i3).a(1)+l1_
     &          34f(i1,i2).c(1)*p134q*r2_56f(i3).b(2) )/(p134q*p134k0)
              cres9(i3,2,i1,i2)=( l1_34f(i1,i2).c(2)*p134q*r2_56f(i3).b(
     &          1)+l1_34f(i1,i2).a(2)*r2_56f(i3).a(2) )/(p134q*p134k0)
            END DO
          END DO
        END DO
**** Diagramma 14 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia14(i3,i).a,bb=dia14(i3,i).b,cc=dia14(i3,i).c,dd=dia14(i3,i).d
* ,a1=u3_56f(i3).a,b1=u3_56f(i3).b,c1=u3_56f(i3).c,d1=u3_56f(i3).d,a2=d4_12f
* (i).a,b2=d4_12f(i).b,c2=d4_12f(i).c,d2=d4_12f(i).d,prq=p356q,m=rmb
            dia14(i3,i).a(1,1)=u3_56f(i3).a(1,1)*d4_12f(i).a(1,1)+u3_5
     &        6f(i3).c(1,2)*p356q*d4_12f(i).b(2,1)
            dia14(i3,i).b(1,1)=rmb*(u3_56f(i3).d(1,1)*d4_12f(i).a(1,1)
     &        +u3_56f(i3).b(1,2)*d4_12f(i).b(2,1))
            dia14(i3,i).c(1,1)=rmb*(u3_56f(i3).a(1,1)*d4_12f(i).d(1,1)
     &        +u3_56f(i3).c(1,2)*d4_12f(i).c(2,1))
            dia14(i3,i).d(1,1)=u3_56f(i3).d(1,1)*p356q*d4_12f(i).d(1,1
     &        )+u3_56f(i3).b(1,2)*d4_12f(i).c(2,1)
            dia14(i3,i).a(1,2)=rmb*(u3_56f(i3).a(1,1)*d4_12f(i).b(1,2)
     &        +u3_56f(i3).c(1,2)*d4_12f(i).a(2,2))
            dia14(i3,i).b(1,2)=u3_56f(i3).d(1,1)*p356q*d4_12f(i).b(1,2
     &        )+u3_56f(i3).b(1,2)*d4_12f(i).a(2,2)
            dia14(i3,i).c(1,2)=u3_56f(i3).a(1,1)*d4_12f(i).c(1,2)+u3_5
     &        6f(i3).c(1,2)*p356q*d4_12f(i).d(2,2)
            dia14(i3,i).d(1,2)=rmb*(u3_56f(i3).d(1,1)*d4_12f(i).c(1,2)
     &        +u3_56f(i3).b(1,2)*d4_12f(i).d(2,2))
            dia14(i3,i).a(2,1)=rmb*(u3_56f(i3).c(2,1)*d4_12f(i).a(1,1)
     &        +u3_56f(i3).a(2,2)*d4_12f(i).b(2,1))
            dia14(i3,i).b(2,1)=u3_56f(i3).b(2,1)*d4_12f(i).a(1,1)+u3_5
     &        6f(i3).d(2,2)*p356q*d4_12f(i).b(2,1)
            dia14(i3,i).c(2,1)=u3_56f(i3).c(2,1)*p356q*d4_12f(i).d(1,1
     &        )+u3_56f(i3).a(2,2)*d4_12f(i).c(2,1)
            dia14(i3,i).d(2,1)=rmb*(u3_56f(i3).b(2,1)*d4_12f(i).d(1,1)
     &        +u3_56f(i3).d(2,2)*d4_12f(i).c(2,1))
            dia14(i3,i).a(2,2)=u3_56f(i3).c(2,1)*p356q*d4_12f(i).b(1,2
     &        )+u3_56f(i3).a(2,2)*d4_12f(i).a(2,2)
            dia14(i3,i).b(2,2)=rmb*(u3_56f(i3).b(2,1)*d4_12f(i).b(1,2)
     &        +u3_56f(i3).d(2,2)*d4_12f(i).a(2,2))
            dia14(i3,i).c(2,2)=rmb*(u3_56f(i3).c(2,1)*d4_12f(i).c(1,2)
     &        +u3_56f(i3).a(2,2)*d4_12f(i).d(2,2))
            dia14(i3,i).d(2,2)=u3_56f(i3).b(2,1)*d4_12f(i).c(1,2)+u3_5
     &        6f(i3).d(2,2)*p356q*d4_12f(i).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres14(i3,i,&),abcd=dia14(i3,i).,m1=rmb,m2=(-rmb),den=((p356
* q-rmb2)*p356k0)
            DO iut=1,2
              DO jut=1,2
                cres14(i3,i,iut,jut)=(dia14(i3,i).a(iut,jut)
     &            +rmb*dia14(i3,
     &            i).b(iut,jut)+(-rmb)*dia14(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a14(i3,i).d(iut,jut))/((p356q-rmb2)*p356k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 16 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia16(i3,i).a,bb=dia16(i3,i).b,cc=dia16(i3,i).c,dd=dia16(i3,i).d
* ,a1=u3_12f(i).a,b1=u3_12f(i).b,c1=u3_12f(i).c,d1=u3_12f(i).d,a2=d4_56f(i3)
* .a,b2=d4_56f(i3).b,c2=d4_56f(i3).c,d2=d4_56f(i3).d,prq=p123q,m=rmb
            dia16(i3,i).a(1,1)=u3_12f(i).a(1,1)*d4_56f(i3).a(1,1)+u3_1
     &        2f(i).c(1,2)*p123q*d4_56f(i3).b(2,1)
            dia16(i3,i).b(1,1)=rmb*(u3_12f(i).d(1,1)*d4_56f(i3).a(1,1)
     &        +u3_12f(i).b(1,2)*d4_56f(i3).b(2,1))
            dia16(i3,i).c(1,1)=rmb*(u3_12f(i).a(1,1)*d4_56f(i3).d(1,1)
     &        +u3_12f(i).c(1,2)*d4_56f(i3).c(2,1))
            dia16(i3,i).d(1,1)=u3_12f(i).d(1,1)*p123q*d4_56f(i3).d(1,1
     &        )+u3_12f(i).b(1,2)*d4_56f(i3).c(2,1)
            dia16(i3,i).a(1,2)=rmb*(u3_12f(i).a(1,1)*d4_56f(i3).b(1,2)
     &        +u3_12f(i).c(1,2)*d4_56f(i3).a(2,2))
            dia16(i3,i).b(1,2)=u3_12f(i).d(1,1)*p123q*d4_56f(i3).b(1,2
     &        )+u3_12f(i).b(1,2)*d4_56f(i3).a(2,2)
            dia16(i3,i).c(1,2)=u3_12f(i).a(1,1)*d4_56f(i3).c(1,2)+u3_1
     &        2f(i).c(1,2)*p123q*d4_56f(i3).d(2,2)
            dia16(i3,i).d(1,2)=rmb*(u3_12f(i).d(1,1)*d4_56f(i3).c(1,2)
     &        +u3_12f(i).b(1,2)*d4_56f(i3).d(2,2))
            dia16(i3,i).a(2,1)=rmb*(u3_12f(i).c(2,1)*d4_56f(i3).a(1,1)
     &        +u3_12f(i).a(2,2)*d4_56f(i3).b(2,1))
            dia16(i3,i).b(2,1)=u3_12f(i).b(2,1)*d4_56f(i3).a(1,1)+u3_1
     &        2f(i).d(2,2)*p123q*d4_56f(i3).b(2,1)
            dia16(i3,i).c(2,1)=u3_12f(i).c(2,1)*p123q*d4_56f(i3).d(1,1
     &        )+u3_12f(i).a(2,2)*d4_56f(i3).c(2,1)
            dia16(i3,i).d(2,1)=rmb*(u3_12f(i).b(2,1)*d4_56f(i3).d(1,1)
     &        +u3_12f(i).d(2,2)*d4_56f(i3).c(2,1))
            dia16(i3,i).a(2,2)=u3_12f(i).c(2,1)*p123q*d4_56f(i3).b(1,2
     &        )+u3_12f(i).a(2,2)*d4_56f(i3).a(2,2)
            dia16(i3,i).b(2,2)=rmb*(u3_12f(i).b(2,1)*d4_56f(i3).b(1,2)
     &        +u3_12f(i).d(2,2)*d4_56f(i3).a(2,2))
            dia16(i3,i).c(2,2)=rmb*(u3_12f(i).c(2,1)*d4_56f(i3).c(1,2)
     &        +u3_12f(i).a(2,2)*d4_56f(i3).d(2,2))
            dia16(i3,i).d(2,2)=u3_12f(i).b(2,1)*d4_56f(i3).c(1,2)+u3_1
     &        2f(i).d(2,2)*p123q*d4_56f(i3).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres16(i3,i,&),abcd=dia16(i3,i).,m1=rmb,m2=(-rmb),den=((p123
* q-rmb2)*p123k0)
            DO iut=1,2
              DO jut=1,2
                cres16(i3,i,iut,jut)=(dia16(i3,i).a(iut,jut)
     &            +rmb*dia16(i3,
     &            i).b(iut,jut)+(-rmb)*dia16(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a16(i3,i).d(iut,jut))/((p123q-rmb2)*p123k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 20 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres20(&,i1,i2,i3),a1=l5_12f(i1).a,c1=l5_12f(i1).c,a2=r6_34f(
* i2,i3).a,b2=r6_34f(i2,i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cres20(1,i1,i2,i3)=( l5_12f(i1).a(1)*r6_34f(i2,i3).a(1)+l5
     &          _12f(i1).c(1)*p125q*r6_34f(i2,i3).b(2) )/(p125q*p125k0)
              cres20(2,i1,i2,i3)=( l5_12f(i1).c(2)*p125q*r6_34f(i2,i3).b
     &          (1)+l5_12f(i1).a(2)*r6_34f(i2,i3).a(2) )/(p125q*p125k0)
            END DO
          END DO
        END DO
**** Diagramma 33 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres33(&,i1,i2,i3),a1=l5_34f(i2,i3).a,c1=l5_34f(i2,i3).c,a2=r
* 6_12f(i1).a,b2=r6_12f(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
              cres33(1,i1,i2,i3)=( l5_34f(i2,i3).a(1)*r6_12f(i1).a(1)+l5
     &          _34f(i2,i3).c(1)*p345q*r6_12f(i1).b(2) )/(p345q*p345k0)
              cres33(2,i1,i2,i3)=( l5_34f(i2,i3).c(2)*p345q*r6_12f(i1).b
     &          (1)+l5_34f(i2,i3).a(2)*r6_12f(i1).a(2) )/(p345q*p345k0)
            END DO
          END DO
        END DO
**** Diagramma 5 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres5(i3,&,i1,i2),a1=l1_56z(i3).a,c1=l1_56z(i3).c,a2=r2_34f(i
* 1,i2).a,b2=r2_34f(i1,i2).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cres5(i3,1,i1,i2)=( l1_56z(i3).a(1)*r2_34f(i1,i2).a(1)+l1_
     &          56z(i3).c(1)*p156q*r2_34f(i1,i2).b(2) )/(p156q*p156k0)
              cres5(i3,2,i1,i2)=( l1_56z(i3).c(2)*p156q*r2_34f(i1,i2).b(
     &          1)+l1_56z(i3).a(2)*r2_34f(i1,i2).a(2) )/(p156q*p156k0)
            END DO
          END DO
        END DO
**** Diagramma 10 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres10(i3,&,i1,i2),a1=l1_34z(i1,i2).a,c1=l1_34z(i1,i2).c,a2=r
* 2_56f(i3).a,b2=r2_56f(i3).b,prq=p134q,den=(p134q*p134k0),nsum=0
              cres10(i3,1,i1,i2)=( l1_34z(i1,i2).a(1)*r2_56f(i3).a(1)+l1
     &          _34z(i1,i2).c(1)*p134q*r2_56f(i3).b(2) )/(p134q*p134k0)
              cres10(i3,2,i1,i2)=( l1_34z(i1,i2).c(2)*p134q*r2_56f(i3).b
     &          (1)+l1_34z(i1,i2).a(2)*r2_56f(i3).a(2) )/(p134q*p134k0)
            END DO
          END DO
        END DO
**** Diagramma 15 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia15(i3,i).a,bb=dia15(i3,i).b,cc=dia15(i3,i).c,dd=dia15(i3,i).d
* ,a1=u3_56z(i3).a,b1=u3_56z(i3).b,c1=u3_56z(i3).c,d1=u3_56z(i3).d,a2=d4_12f
* (i).a,b2=d4_12f(i).b,c2=d4_12f(i).c,d2=d4_12f(i).d,prq=p356q,m=rmb
            dia15(i3,i).a(1,1)=u3_56z(i3).a(1,1)*d4_12f(i).a(1,1)+u3_5
     &        6z(i3).c(1,2)*p356q*d4_12f(i).b(2,1)
            dia15(i3,i).b(1,1)=rmb*(u3_56z(i3).d(1,1)*d4_12f(i).a(1,1)
     &        +u3_56z(i3).b(1,2)*d4_12f(i).b(2,1))
            dia15(i3,i).c(1,1)=rmb*(u3_56z(i3).a(1,1)*d4_12f(i).d(1,1)
     &        +u3_56z(i3).c(1,2)*d4_12f(i).c(2,1))
            dia15(i3,i).d(1,1)=u3_56z(i3).d(1,1)*p356q*d4_12f(i).d(1,1
     &        )+u3_56z(i3).b(1,2)*d4_12f(i).c(2,1)
            dia15(i3,i).a(1,2)=rmb*(u3_56z(i3).a(1,1)*d4_12f(i).b(1,2)
     &        +u3_56z(i3).c(1,2)*d4_12f(i).a(2,2))
            dia15(i3,i).b(1,2)=u3_56z(i3).d(1,1)*p356q*d4_12f(i).b(1,2
     &        )+u3_56z(i3).b(1,2)*d4_12f(i).a(2,2)
            dia15(i3,i).c(1,2)=u3_56z(i3).a(1,1)*d4_12f(i).c(1,2)+u3_5
     &        6z(i3).c(1,2)*p356q*d4_12f(i).d(2,2)
            dia15(i3,i).d(1,2)=rmb*(u3_56z(i3).d(1,1)*d4_12f(i).c(1,2)
     &        +u3_56z(i3).b(1,2)*d4_12f(i).d(2,2))
            dia15(i3,i).a(2,1)=rmb*(u3_56z(i3).c(2,1)*d4_12f(i).a(1,1)
     &        +u3_56z(i3).a(2,2)*d4_12f(i).b(2,1))
            dia15(i3,i).b(2,1)=u3_56z(i3).b(2,1)*d4_12f(i).a(1,1)+u3_5
     &        6z(i3).d(2,2)*p356q*d4_12f(i).b(2,1)
            dia15(i3,i).c(2,1)=u3_56z(i3).c(2,1)*p356q*d4_12f(i).d(1,1
     &        )+u3_56z(i3).a(2,2)*d4_12f(i).c(2,1)
            dia15(i3,i).d(2,1)=rmb*(u3_56z(i3).b(2,1)*d4_12f(i).d(1,1)
     &        +u3_56z(i3).d(2,2)*d4_12f(i).c(2,1))
            dia15(i3,i).a(2,2)=u3_56z(i3).c(2,1)*p356q*d4_12f(i).b(1,2
     &        )+u3_56z(i3).a(2,2)*d4_12f(i).a(2,2)
            dia15(i3,i).b(2,2)=rmb*(u3_56z(i3).b(2,1)*d4_12f(i).b(1,2)
     &        +u3_56z(i3).d(2,2)*d4_12f(i).a(2,2))
            dia15(i3,i).c(2,2)=rmb*(u3_56z(i3).c(2,1)*d4_12f(i).c(1,2)
     &        +u3_56z(i3).a(2,2)*d4_12f(i).d(2,2))
            dia15(i3,i).d(2,2)=u3_56z(i3).b(2,1)*d4_12f(i).c(1,2)+u3_5
     &        6z(i3).d(2,2)*p356q*d4_12f(i).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres15(i3,i,&),abcd=dia15(i3,i).,m1=rmb,m2=(-rmb),den=((p356
* q-rmb2)*p356k0)
            DO iut=1,2
              DO jut=1,2
                cres15(i3,i,iut,jut)=(dia15(i3,i).a(iut,jut)
     &            +rmb*dia15(i3,
     &            i).b(iut,jut)+(-rmb)*dia15(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a15(i3,i).d(iut,jut))/((p356q-rmb2)*p356k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 17 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia17(i3,i).a,bb=dia17(i3,i).b,cc=dia17(i3,i).c,dd=dia17(i3,i).d
* ,a1=u3_12z(i).a,b1=u3_12z(i).b,c1=u3_12z(i).c,d1=u3_12z(i).d,a2=d4_56f(i3)
* .a,b2=d4_56f(i3).b,c2=d4_56f(i3).c,d2=d4_56f(i3).d,prq=p123q,m=rmb
            dia17(i3,i).a(1,1)=u3_12z(i).a(1,1)*d4_56f(i3).a(1,1)+u3_1
     &        2z(i).c(1,2)*p123q*d4_56f(i3).b(2,1)
            dia17(i3,i).b(1,1)=rmb*(u3_12z(i).d(1,1)*d4_56f(i3).a(1,1)
     &        +u3_12z(i).b(1,2)*d4_56f(i3).b(2,1))
            dia17(i3,i).c(1,1)=rmb*(u3_12z(i).a(1,1)*d4_56f(i3).d(1,1)
     &        +u3_12z(i).c(1,2)*d4_56f(i3).c(2,1))
            dia17(i3,i).d(1,1)=u3_12z(i).d(1,1)*p123q*d4_56f(i3).d(1,1
     &        )+u3_12z(i).b(1,2)*d4_56f(i3).c(2,1)
            dia17(i3,i).a(1,2)=rmb*(u3_12z(i).a(1,1)*d4_56f(i3).b(1,2)
     &        +u3_12z(i).c(1,2)*d4_56f(i3).a(2,2))
            dia17(i3,i).b(1,2)=u3_12z(i).d(1,1)*p123q*d4_56f(i3).b(1,2
     &        )+u3_12z(i).b(1,2)*d4_56f(i3).a(2,2)
            dia17(i3,i).c(1,2)=u3_12z(i).a(1,1)*d4_56f(i3).c(1,2)+u3_1
     &        2z(i).c(1,2)*p123q*d4_56f(i3).d(2,2)
            dia17(i3,i).d(1,2)=rmb*(u3_12z(i).d(1,1)*d4_56f(i3).c(1,2)
     &        +u3_12z(i).b(1,2)*d4_56f(i3).d(2,2))
            dia17(i3,i).a(2,1)=rmb*(u3_12z(i).c(2,1)*d4_56f(i3).a(1,1)
     &        +u3_12z(i).a(2,2)*d4_56f(i3).b(2,1))
            dia17(i3,i).b(2,1)=u3_12z(i).b(2,1)*d4_56f(i3).a(1,1)+u3_1
     &        2z(i).d(2,2)*p123q*d4_56f(i3).b(2,1)
            dia17(i3,i).c(2,1)=u3_12z(i).c(2,1)*p123q*d4_56f(i3).d(1,1
     &        )+u3_12z(i).a(2,2)*d4_56f(i3).c(2,1)
            dia17(i3,i).d(2,1)=rmb*(u3_12z(i).b(2,1)*d4_56f(i3).d(1,1)
     &        +u3_12z(i).d(2,2)*d4_56f(i3).c(2,1))
            dia17(i3,i).a(2,2)=u3_12z(i).c(2,1)*p123q*d4_56f(i3).b(1,2
     &        )+u3_12z(i).a(2,2)*d4_56f(i3).a(2,2)
            dia17(i3,i).b(2,2)=rmb*(u3_12z(i).b(2,1)*d4_56f(i3).b(1,2)
     &        +u3_12z(i).d(2,2)*d4_56f(i3).a(2,2))
            dia17(i3,i).c(2,2)=rmb*(u3_12z(i).c(2,1)*d4_56f(i3).c(1,2)
     &        +u3_12z(i).a(2,2)*d4_56f(i3).d(2,2))
            dia17(i3,i).d(2,2)=u3_12z(i).b(2,1)*d4_56f(i3).c(1,2)+u3_1
     &        2z(i).d(2,2)*p123q*d4_56f(i3).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres17(i3,i,&),abcd=dia17(i3,i).,m1=rmb,m2=(-rmb),den=((p123
* q-rmb2)*p123k0)
            DO iut=1,2
              DO jut=1,2
                cres17(i3,i,iut,jut)=(dia17(i3,i).a(iut,jut)
     &            +rmb*dia17(i3,
     &            i).b(iut,jut)+(-rmb)*dia17(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a17(i3,i).d(iut,jut))/((p123q-rmb2)*p123k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 30 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres30(&,i1,i2,i3),a1=l5_12z(i1).a,c1=l5_12z(i1).c,a2=r6_34f(
* i2,i3).a,b2=r6_34f(i2,i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cres30(1,i1,i2,i3)=( l5_12z(i1).a(1)*r6_34f(i2,i3).a(1)+l5
     &          _12z(i1).c(1)*p125q*r6_34f(i2,i3).b(2) )/(p125q*p125k0)
              cres30(2,i1,i2,i3)=( l5_12z(i1).c(2)*p125q*r6_34f(i2,i3).b
     &          (1)+l5_12z(i1).a(2)*r6_34f(i2,i3).a(2) )/(p125q*p125k0)
            END DO
          END DO
        END DO
**** Diagramma 34 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres34(&,i1,i2,i3),a1=l5_34z(i2,i3).a,c1=l5_34z(i2,i3).c,a2=r
* 6_12f(i1).a,b2=r6_12f(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
              cres34(1,i1,i2,i3)=( l5_34z(i2,i3).a(1)*r6_12f(i1).a(1)+l5
     &          _34z(i2,i3).c(1)*p345q*r6_12f(i1).b(2) )/(p345q*p345k0)
              cres34(2,i1,i2,i3)=( l5_34z(i2,i3).c(2)*p345q*r6_12f(i1).b
     &          (1)+l5_34z(i2,i3).a(2)*r6_12f(i1).a(2) )/(p345q*p345k0)
            END DO
          END DO
        END DO
**** Diagramma 22 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres22(i3,&,i1,i2),a1=l1_56z(i3).a,c1=l1_56z(i3).c,a2=r2_34z(
* i1,i2).a,b2=r2_34z(i1,i2).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cres22(i3,1,i1,i2)=( l1_56z(i3).a(1)*r2_34z(i1,i2).a(1)+l1
     &          _56z(i3).c(1)*p156q*r2_34z(i1,i2).b(2) )/(p156q*p156k0)
              cres22(i3,2,i1,i2)=( l1_56z(i3).c(2)*p156q*r2_34z(i1,i2).b
     &          (1)+l1_56z(i3).a(2)*r2_34z(i1,i2).a(2) )/(p156q*p156k0)
            END DO
          END DO
        END DO
**** Diagramma 24 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres24(i3,&,i1,i2),a1=l1_34z(i1,i2).a,c1=l1_34z(i1,i2).c,a2=r
* 2_56z(i3).a,b2=r2_56z(i3).b,prq=p134q,den=(p134q*p134k0),nsum=0
              cres24(i3,1,i1,i2)=( l1_34z(i1,i2).a(1)*r2_56z(i3).a(1)+l1
     &          _34z(i1,i2).c(1)*p134q*r2_56z(i3).b(2) )/(p134q*p134k0)
              cres24(i3,2,i1,i2)=( l1_34z(i1,i2).c(2)*p134q*r2_56z(i3).b
     &          (1)+l1_34z(i1,i2).a(2)*r2_56z(i3).a(2) )/(p134q*p134k0)
            END DO
          END DO
        END DO
**** Diagramma 26 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia26(i3,i).a,bb=dia26(i3,i).b,cc=dia26(i3,i).c,dd=dia26(i3,i).d
* ,a1=u3_56z(i3).a,b1=u3_56z(i3).b,c1=u3_56z(i3).c,d1=u3_56z(i3).d,a2=d4_12z
* (i).a,b2=d4_12z(i).b,c2=d4_12z(i).c,d2=d4_12z(i).d,prq=p356q,m=rmb
            dia26(i3,i).a(1,1)=u3_56z(i3).a(1,1)*d4_12z(i).a(1,1)+u3_5
     &        6z(i3).c(1,2)*p356q*d4_12z(i).b(2,1)
            dia26(i3,i).b(1,1)=rmb*(u3_56z(i3).d(1,1)*d4_12z(i).a(1,1)
     &        +u3_56z(i3).b(1,2)*d4_12z(i).b(2,1))
            dia26(i3,i).c(1,1)=rmb*(u3_56z(i3).a(1,1)*d4_12z(i).d(1,1)
     &        +u3_56z(i3).c(1,2)*d4_12z(i).c(2,1))
            dia26(i3,i).d(1,1)=u3_56z(i3).d(1,1)*p356q*d4_12z(i).d(1,1
     &        )+u3_56z(i3).b(1,2)*d4_12z(i).c(2,1)
            dia26(i3,i).a(1,2)=rmb*(u3_56z(i3).a(1,1)*d4_12z(i).b(1,2)
     &        +u3_56z(i3).c(1,2)*d4_12z(i).a(2,2))
            dia26(i3,i).b(1,2)=u3_56z(i3).d(1,1)*p356q*d4_12z(i).b(1,2
     &        )+u3_56z(i3).b(1,2)*d4_12z(i).a(2,2)
            dia26(i3,i).c(1,2)=u3_56z(i3).a(1,1)*d4_12z(i).c(1,2)+u3_5
     &        6z(i3).c(1,2)*p356q*d4_12z(i).d(2,2)
            dia26(i3,i).d(1,2)=rmb*(u3_56z(i3).d(1,1)*d4_12z(i).c(1,2)
     &        +u3_56z(i3).b(1,2)*d4_12z(i).d(2,2))
            dia26(i3,i).a(2,1)=rmb*(u3_56z(i3).c(2,1)*d4_12z(i).a(1,1)
     &        +u3_56z(i3).a(2,2)*d4_12z(i).b(2,1))
            dia26(i3,i).b(2,1)=u3_56z(i3).b(2,1)*d4_12z(i).a(1,1)+u3_5
     &        6z(i3).d(2,2)*p356q*d4_12z(i).b(2,1)
            dia26(i3,i).c(2,1)=u3_56z(i3).c(2,1)*p356q*d4_12z(i).d(1,1
     &        )+u3_56z(i3).a(2,2)*d4_12z(i).c(2,1)
            dia26(i3,i).d(2,1)=rmb*(u3_56z(i3).b(2,1)*d4_12z(i).d(1,1)
     &        +u3_56z(i3).d(2,2)*d4_12z(i).c(2,1))
            dia26(i3,i).a(2,2)=u3_56z(i3).c(2,1)*p356q*d4_12z(i).b(1,2
     &        )+u3_56z(i3).a(2,2)*d4_12z(i).a(2,2)
            dia26(i3,i).b(2,2)=rmb*(u3_56z(i3).b(2,1)*d4_12z(i).b(1,2)
     &        +u3_56z(i3).d(2,2)*d4_12z(i).a(2,2))
            dia26(i3,i).c(2,2)=rmb*(u3_56z(i3).c(2,1)*d4_12z(i).c(1,2)
     &        +u3_56z(i3).a(2,2)*d4_12z(i).d(2,2))
            dia26(i3,i).d(2,2)=u3_56z(i3).b(2,1)*d4_12z(i).c(1,2)+u3_5
     &        6z(i3).d(2,2)*p356q*d4_12z(i).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres26(i3,i,&),abcd=dia26(i3,i).,m1=rmb,m2=(-rmb),den=((p356
* q-rmb2)*p356k0)
            DO iut=1,2
              DO jut=1,2
                cres26(i3,i,iut,jut)=(dia26(i3,i).a(iut,jut)
     &            +rmb*dia26(i3,
     &            i).b(iut,jut)+(-rmb)*dia26(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a26(i3,i).d(iut,jut))/((p356q-rmb2)*p356k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 28 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia28(i3,i).a,bb=dia28(i3,i).b,cc=dia28(i3,i).c,dd=dia28(i3,i).d
* ,a1=u3_12z(i).a,b1=u3_12z(i).b,c1=u3_12z(i).c,d1=u3_12z(i).d,a2=d4_56z(i3)
* .a,b2=d4_56z(i3).b,c2=d4_56z(i3).c,d2=d4_56z(i3).d,prq=p123q,m=rmb
            dia28(i3,i).a(1,1)=u3_12z(i).a(1,1)*d4_56z(i3).a(1,1)+u3_1
     &        2z(i).c(1,2)*p123q*d4_56z(i3).b(2,1)
            dia28(i3,i).b(1,1)=rmb*(u3_12z(i).d(1,1)*d4_56z(i3).a(1,1)
     &        +u3_12z(i).b(1,2)*d4_56z(i3).b(2,1))
            dia28(i3,i).c(1,1)=rmb*(u3_12z(i).a(1,1)*d4_56z(i3).d(1,1)
     &        +u3_12z(i).c(1,2)*d4_56z(i3).c(2,1))
            dia28(i3,i).d(1,1)=u3_12z(i).d(1,1)*p123q*d4_56z(i3).d(1,1
     &        )+u3_12z(i).b(1,2)*d4_56z(i3).c(2,1)
            dia28(i3,i).a(1,2)=rmb*(u3_12z(i).a(1,1)*d4_56z(i3).b(1,2)
     &        +u3_12z(i).c(1,2)*d4_56z(i3).a(2,2))
            dia28(i3,i).b(1,2)=u3_12z(i).d(1,1)*p123q*d4_56z(i3).b(1,2
     &        )+u3_12z(i).b(1,2)*d4_56z(i3).a(2,2)
            dia28(i3,i).c(1,2)=u3_12z(i).a(1,1)*d4_56z(i3).c(1,2)+u3_1
     &        2z(i).c(1,2)*p123q*d4_56z(i3).d(2,2)
            dia28(i3,i).d(1,2)=rmb*(u3_12z(i).d(1,1)*d4_56z(i3).c(1,2)
     &        +u3_12z(i).b(1,2)*d4_56z(i3).d(2,2))
            dia28(i3,i).a(2,1)=rmb*(u3_12z(i).c(2,1)*d4_56z(i3).a(1,1)
     &        +u3_12z(i).a(2,2)*d4_56z(i3).b(2,1))
            dia28(i3,i).b(2,1)=u3_12z(i).b(2,1)*d4_56z(i3).a(1,1)+u3_1
     &        2z(i).d(2,2)*p123q*d4_56z(i3).b(2,1)
            dia28(i3,i).c(2,1)=u3_12z(i).c(2,1)*p123q*d4_56z(i3).d(1,1
     &        )+u3_12z(i).a(2,2)*d4_56z(i3).c(2,1)
            dia28(i3,i).d(2,1)=rmb*(u3_12z(i).b(2,1)*d4_56z(i3).d(1,1)
     &        +u3_12z(i).d(2,2)*d4_56z(i3).c(2,1))
            dia28(i3,i).a(2,2)=u3_12z(i).c(2,1)*p123q*d4_56z(i3).b(1,2
     &        )+u3_12z(i).a(2,2)*d4_56z(i3).a(2,2)
            dia28(i3,i).b(2,2)=rmb*(u3_12z(i).b(2,1)*d4_56z(i3).b(1,2)
     &        +u3_12z(i).d(2,2)*d4_56z(i3).a(2,2))
            dia28(i3,i).c(2,2)=rmb*(u3_12z(i).c(2,1)*d4_56z(i3).c(1,2)
     &        +u3_12z(i).a(2,2)*d4_56z(i3).d(2,2))
            dia28(i3,i).d(2,2)=u3_12z(i).b(2,1)*d4_56z(i3).c(1,2)+u3_1
     &        2z(i).d(2,2)*p123q*d4_56z(i3).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres28(i3,i,&),abcd=dia28(i3,i).,m1=rmb,m2=(-rmb),den=((p123
* q-rmb2)*p123k0)
            DO iut=1,2
              DO jut=1,2
                cres28(i3,i,iut,jut)=(dia28(i3,i).a(iut,jut)
     &            +rmb*dia28(i3,
     &            i).b(iut,jut)+(-rmb)*dia28(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a28(i3,i).d(iut,jut))/((p123q-rmb2)*p123k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 31 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres31(&,i1,i2,i3),a1=l5_12z(i1).a,c1=l5_12z(i1).c,a2=r6_34z(
* i2,i3).a,b2=r6_34z(i2,i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cres31(1,i1,i2,i3)=( l5_12z(i1).a(1)*r6_34z(i2,i3).a(1)+l5
     &          _12z(i1).c(1)*p125q*r6_34z(i2,i3).b(2) )/(p125q*p125k0)
              cres31(2,i1,i2,i3)=( l5_12z(i1).c(2)*p125q*r6_34z(i2,i3).b
     &          (1)+l5_12z(i1).a(2)*r6_34z(i2,i3).a(2) )/(p125q*p125k0)
            END DO
          END DO
        END DO
**** Diagramma 35 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres35(&,i1,i2,i3),a1=l5_34z(i2,i3).a,c1=l5_34z(i2,i3).c,a2=r
* 6_12z(i1).a,b2=r6_12z(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
              cres35(1,i1,i2,i3)=( l5_34z(i2,i3).a(1)*r6_12z(i1).a(1)+l5
     &          _34z(i2,i3).c(1)*p345q*r6_12z(i1).b(2) )/(p345q*p345k0)
              cres35(2,i1,i2,i3)=( l5_34z(i2,i3).c(2)*p345q*r6_12z(i1).b
     &          (1)+l5_34z(i2,i3).a(2)*r6_12z(i1).a(2) )/(p345q*p345k0)
            END DO
          END DO
        END DO
**** Diagramma 23 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres23(i3,&,i1,i2),a1=l1_56f(i3).a,c1=l1_56f(i3).c,a2=r2_34z(
* i1,i2).a,b2=r2_34z(i1,i2).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cres23(i3,1,i1,i2)=( l1_56f(i3).a(1)*r2_34z(i1,i2).a(1)+l1
     &          _56f(i3).c(1)*p156q*r2_34z(i1,i2).b(2) )/(p156q*p156k0)
              cres23(i3,2,i1,i2)=( l1_56f(i3).c(2)*p156q*r2_34z(i1,i2).b
     &          (1)+l1_56f(i3).a(2)*r2_34z(i1,i2).a(2) )/(p156q*p156k0)
            END DO
          END DO
        END DO
**** Diagramma 25 ****
        DO i3=1,2
          DO i1=1,2
            DO i2=1,2
* TLTR0 -- aa=cres25(i3,&,i1,i2),a1=l1_34f(i1,i2).a,c1=l1_34f(i1,i2).c,a2=r
* 2_56z(i3).a,b2=r2_56z(i3).b,prq=p134q,den=(p134q*p134k0),nsum=0
              cres25(i3,1,i1,i2)=( l1_34f(i1,i2).a(1)*r2_56z(i3).a(1)+l1
     &          _34f(i1,i2).c(1)*p134q*r2_56z(i3).b(2) )/(p134q*p134k0)
              cres25(i3,2,i1,i2)=( l1_34f(i1,i2).c(2)*p134q*r2_56z(i3).b
     &          (1)+l1_34f(i1,i2).a(2)*r2_56z(i3).a(2) )/(p134q*p134k0)
            END DO
          END DO
        END DO
**** Diagramma 27 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia27(i3,i).a,bb=dia27(i3,i).b,cc=dia27(i3,i).c,dd=dia27(i3,i).d
* ,a1=u3_56f(i3).a,b1=u3_56f(i3).b,c1=u3_56f(i3).c,d1=u3_56f(i3).d,a2=d4_12z
* (i).a,b2=d4_12z(i).b,c2=d4_12z(i).c,d2=d4_12z(i).d,prq=p356q,m=rmb
            dia27(i3,i).a(1,1)=u3_56f(i3).a(1,1)*d4_12z(i).a(1,1)+u3_5
     &        6f(i3).c(1,2)*p356q*d4_12z(i).b(2,1)
            dia27(i3,i).b(1,1)=rmb*(u3_56f(i3).d(1,1)*d4_12z(i).a(1,1)
     &        +u3_56f(i3).b(1,2)*d4_12z(i).b(2,1))
            dia27(i3,i).c(1,1)=rmb*(u3_56f(i3).a(1,1)*d4_12z(i).d(1,1)
     &        +u3_56f(i3).c(1,2)*d4_12z(i).c(2,1))
            dia27(i3,i).d(1,1)=u3_56f(i3).d(1,1)*p356q*d4_12z(i).d(1,1
     &        )+u3_56f(i3).b(1,2)*d4_12z(i).c(2,1)
            dia27(i3,i).a(1,2)=rmb*(u3_56f(i3).a(1,1)*d4_12z(i).b(1,2)
     &        +u3_56f(i3).c(1,2)*d4_12z(i).a(2,2))
            dia27(i3,i).b(1,2)=u3_56f(i3).d(1,1)*p356q*d4_12z(i).b(1,2
     &        )+u3_56f(i3).b(1,2)*d4_12z(i).a(2,2)
            dia27(i3,i).c(1,2)=u3_56f(i3).a(1,1)*d4_12z(i).c(1,2)+u3_5
     &        6f(i3).c(1,2)*p356q*d4_12z(i).d(2,2)
            dia27(i3,i).d(1,2)=rmb*(u3_56f(i3).d(1,1)*d4_12z(i).c(1,2)
     &        +u3_56f(i3).b(1,2)*d4_12z(i).d(2,2))
            dia27(i3,i).a(2,1)=rmb*(u3_56f(i3).c(2,1)*d4_12z(i).a(1,1)
     &        +u3_56f(i3).a(2,2)*d4_12z(i).b(2,1))
            dia27(i3,i).b(2,1)=u3_56f(i3).b(2,1)*d4_12z(i).a(1,1)+u3_5
     &        6f(i3).d(2,2)*p356q*d4_12z(i).b(2,1)
            dia27(i3,i).c(2,1)=u3_56f(i3).c(2,1)*p356q*d4_12z(i).d(1,1
     &        )+u3_56f(i3).a(2,2)*d4_12z(i).c(2,1)
            dia27(i3,i).d(2,1)=rmb*(u3_56f(i3).b(2,1)*d4_12z(i).d(1,1)
     &        +u3_56f(i3).d(2,2)*d4_12z(i).c(2,1))
            dia27(i3,i).a(2,2)=u3_56f(i3).c(2,1)*p356q*d4_12z(i).b(1,2
     &        )+u3_56f(i3).a(2,2)*d4_12z(i).a(2,2)
            dia27(i3,i).b(2,2)=rmb*(u3_56f(i3).b(2,1)*d4_12z(i).b(1,2)
     &        +u3_56f(i3).d(2,2)*d4_12z(i).a(2,2))
            dia27(i3,i).c(2,2)=rmb*(u3_56f(i3).c(2,1)*d4_12z(i).c(1,2)
     &        +u3_56f(i3).a(2,2)*d4_12z(i).d(2,2))
            dia27(i3,i).d(2,2)=u3_56f(i3).b(2,1)*d4_12z(i).c(1,2)+u3_5
     &        6f(i3).d(2,2)*p356q*d4_12z(i).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres27(i3,i,&),abcd=dia27(i3,i).,m1=rmb,m2=(-rmb),den=((p356
* q-rmb2)*p356k0)
            DO iut=1,2
              DO jut=1,2
                cres27(i3,i,iut,jut)=(dia27(i3,i).a(iut,jut)
     &            +rmb*dia27(i3,
     &            i).b(iut,jut)+(-rmb)*dia27(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a27(i3,i).d(iut,jut))/((p356q-rmb2)*p356k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 29 ****
        DO i3=1,2
          DO i=1,2
* TT -- aa=dia29(i3,i).a,bb=dia29(i3,i).b,cc=dia29(i3,i).c,dd=dia29(i3,i).d
* ,a1=u3_12f(i).a,b1=u3_12f(i).b,c1=u3_12f(i).c,d1=u3_12f(i).d,a2=d4_56z(i3)
* .a,b2=d4_56z(i3).b,c2=d4_56z(i3).c,d2=d4_56z(i3).d,prq=p123q,m=rmb
            dia29(i3,i).a(1,1)=u3_12f(i).a(1,1)*d4_56z(i3).a(1,1)+u3_1
     &        2f(i).c(1,2)*p123q*d4_56z(i3).b(2,1)
            dia29(i3,i).b(1,1)=rmb*(u3_12f(i).d(1,1)*d4_56z(i3).a(1,1)
     &        +u3_12f(i).b(1,2)*d4_56z(i3).b(2,1))
            dia29(i3,i).c(1,1)=rmb*(u3_12f(i).a(1,1)*d4_56z(i3).d(1,1)
     &        +u3_12f(i).c(1,2)*d4_56z(i3).c(2,1))
            dia29(i3,i).d(1,1)=u3_12f(i).d(1,1)*p123q*d4_56z(i3).d(1,1
     &        )+u3_12f(i).b(1,2)*d4_56z(i3).c(2,1)
            dia29(i3,i).a(1,2)=rmb*(u3_12f(i).a(1,1)*d4_56z(i3).b(1,2)
     &        +u3_12f(i).c(1,2)*d4_56z(i3).a(2,2))
            dia29(i3,i).b(1,2)=u3_12f(i).d(1,1)*p123q*d4_56z(i3).b(1,2
     &        )+u3_12f(i).b(1,2)*d4_56z(i3).a(2,2)
            dia29(i3,i).c(1,2)=u3_12f(i).a(1,1)*d4_56z(i3).c(1,2)+u3_1
     &        2f(i).c(1,2)*p123q*d4_56z(i3).d(2,2)
            dia29(i3,i).d(1,2)=rmb*(u3_12f(i).d(1,1)*d4_56z(i3).c(1,2)
     &        +u3_12f(i).b(1,2)*d4_56z(i3).d(2,2))
            dia29(i3,i).a(2,1)=rmb*(u3_12f(i).c(2,1)*d4_56z(i3).a(1,1)
     &        +u3_12f(i).a(2,2)*d4_56z(i3).b(2,1))
            dia29(i3,i).b(2,1)=u3_12f(i).b(2,1)*d4_56z(i3).a(1,1)+u3_1
     &        2f(i).d(2,2)*p123q*d4_56z(i3).b(2,1)
            dia29(i3,i).c(2,1)=u3_12f(i).c(2,1)*p123q*d4_56z(i3).d(1,1
     &        )+u3_12f(i).a(2,2)*d4_56z(i3).c(2,1)
            dia29(i3,i).d(2,1)=rmb*(u3_12f(i).b(2,1)*d4_56z(i3).d(1,1)
     &        +u3_12f(i).d(2,2)*d4_56z(i3).c(2,1))
            dia29(i3,i).a(2,2)=u3_12f(i).c(2,1)*p123q*d4_56z(i3).b(1,2
     &        )+u3_12f(i).a(2,2)*d4_56z(i3).a(2,2)
            dia29(i3,i).b(2,2)=rmb*(u3_12f(i).b(2,1)*d4_56z(i3).b(1,2)
     &        +u3_12f(i).d(2,2)*d4_56z(i3).a(2,2))
            dia29(i3,i).c(2,2)=rmb*(u3_12f(i).c(2,1)*d4_56z(i3).c(1,2)
     &        +u3_12f(i).a(2,2)*d4_56z(i3).d(2,2))
            dia29(i3,i).d(2,2)=u3_12f(i).b(2,1)*d4_56z(i3).c(1,2)+u3_1
     &        2f(i).d(2,2)*p123q*d4_56z(i3).d(2,2)
          END DO
        END DO
        DO i3=1,2
          DO i=1,2
* mline -- res=cres29(i3,i,&),abcd=dia29(i3,i).,m1=rmb,m2=(-rmb),den=((p123
* q-rmb2)*p123k0)
            DO iut=1,2
              DO jut=1,2
                cres29(i3,i,iut,jut)=(dia29(i3,i).a(iut,jut)
     &            +rmb*dia29(i3,
     &            i).b(iut,jut)+(-rmb)*dia29(i3,i).c(iut,jut)+rmb*(-rmb)
     &            *di
     &            a29(i3,i).d(iut,jut))/((p123q-rmb2)*p123k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma 32 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres32(&,i1,i2,i3),a1=l5_12f(i1).a,c1=l5_12f(i1).c,a2=r6_34z(
* i2,i3).a,b2=r6_34z(i2,i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cres32(1,i1,i2,i3)=( l5_12f(i1).a(1)*r6_34z(i2,i3).a(1)+l5
     &          _12f(i1).c(1)*p125q*r6_34z(i2,i3).b(2) )/(p125q*p125k0)
              cres32(2,i1,i2,i3)=( l5_12f(i1).c(2)*p125q*r6_34z(i2,i3).b
     &          (1)+l5_12f(i1).a(2)*r6_34z(i2,i3).a(2) )/(p125q*p125k0)
            END DO
          END DO
        END DO
**** Diagramma 21 ****
        DO i1=1,2
          DO i2=1,2
            DO i3=1,2
* TLTR0 -- aa=cres21(&,i1,i2,i3),a1=l5_34f(i2,i3).a,c1=l5_34f(i2,i3).c,a2=r
* 6_12z(i1).a,b2=r6_12z(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
              cres21(1,i1,i2,i3)=( l5_34f(i2,i3).a(1)*r6_12z(i1).a(1)+l5
     &          _34f(i2,i3).c(1)*p345q*r6_12z(i1).b(2) )/(p345q*p345k0)
              cres21(2,i1,i2,i3)=( l5_34f(i2,i3).c(2)*p345q*r6_12z(i1).b
     &          (1)+l5_34f(i2,i3).a(2)*r6_12z(i1).a(2) )/(p345q*p345k0)
            END DO
          END DO
        END DO
      ENDIF
      IF (imix.EQ.1.OR.imix.EQ.-2) then
*        Diagramma (17)   segnale di Higgs
* Vertice b b~ H ( quarks massivi )
* quqd -- p=p3,q=p4
        quqd=p3(0)*p4(0)-p3(1)*p4(1)-p3(2)*p4(2)-p3(3)*p4(3)
        cdh=-(2.d0*(quqd+rmb2)*chipr-rmh2+cch)
* TH -- qu=p3,qd=p4,a=v3_4h.a,b=v3_4h.b,c=v3_4h.c
        v3_4h.a(1,2)=-p3k0*p4(2)+p4k0*p3(2)-cim*(p4(3)*p3k0-p3(3)*
     &    p4k0)
        v3_4h.a(2,1)=-conjg(v3_4h.a(1,2))
        v3_4h.b(1,1)=p4k0
        v3_4h.b(2,2)=v3_4h.b(1,1)
        v3_4h.c(1,1)=p3k0
        v3_4h.c(2,2)=v3_4h.c(1,1)
* mline -- res=c34h(&),abcd=v3_4h.,m1=rmb,m2=(-rmb),den=cdh
        DO iut=1,2
          DO jut=1,2
            c34h(iut,jut)=(v3_4h.a(iut,jut)+rmb*v3_4h.b(iut,jut)+(-rmb
     &        )*v3_4h.c(iut,jut)+rmb*(-rmb)*v3_4h.d(iut,jut))/cdh
          ENDDO
        ENDDO
        DO i1=1,2
          DO i3=1,2
            DO i4=1,2
              DO i5=1,2
                cres36(i5,i1,i3,i4)=rhzz*(c56z(i5).e(0)*c12z(i1).e(0)-
     &            c56z(i5).e(1)*c12z(i1).e(1)-c56z(i5).e(2)*
     &            c12z(i1).e(2)-c56z(i5).e(3)*c12z(i1).e(3))*c34h(i3,i4)
              ENDDO !i5
            ENDDO !i4
          ENDDO !i3
        ENDDO !i1
      ENDIF
******************************AUTOMEND*******************************

      if (ifirst.eq.1) then
        IF(istrcor.EQ.1)THEN
          qcdcor=qcdcor_nc
          IF((i3q.EQ.1.AND.i5q.EQ.0).OR.(i3q.EQ.0.AND.i5q.EQ.1))THEN
            fatcor_qcd=1.d0/(1.d0+qcdcor)
            fatcor_hh=(1.d0+qcdcor_h)/(1.d0+qcdcor)
            fatcor_hz=sqrt((1.d0+qcdcor)*(1.d0+qcdcor_h))/(1.d0+qcdcor)
          ELSE IF(i3q.EQ.1.AND.i5q.EQ.1)THEN
            fatcor_qcd=1.d0/(1.d0+qcdcor)**2
            fatcor_hh=(1.d0+qcdcor)*(1.d0+qcdcor_h)/
     &      (1.d0+qcdcor)**2
            fatcor_hz=(1.d0+qcdcor)*sqrt((1.d0+qcdcor)*(1.d0+qcdcor_h))
     &      /(1.d0+qcdcor)**2
          ENDIF
        ELSE
          fatcor_qcd=1.d0
          fatcor_hh=1.d0
          fatcor_hz=1.d0
        ENDIF
        ifirst=0
      endif

      res=0.d0
      DO l=1,2
        DO k=1,2
          DO i=1,2
            DO j=1,2
              IF (imix.EQ.-1.or.imix.eq.-2) then
                cres=+cres4(l,k,i,j)+cres5(l,k,i,j)+cres9(l,k,i,j)
     &             +cres10(l,k,i,j)+cres14(l,k,i,j)+cres15(l,k,i,j)
     &             +cres16(l,k,i,j)+cres17(l,k,i,j)+cres20(l,k,i,j)
     &             +cres21(l,k,i,j)+cres22(l,k,i,j)+cres23(l,k,i,j)
     &             +cres24(l,k,i,j)+cres25(l,k,i,j)+cres26(l,k,i,j)
     &             +cres27(l,k,i,j)+cres28(l,k,i,j)+cres29(l,k,i,j)
     &             +cres30(l,k,i,j)+cres31(l,k,i,j)+cres32(l,k,i,j)
     &             +cres33(l,k,i,j)+cres34(l,k,i,j)+cres35(l,k,i,j)
                res=res+dreal(cres)**2+dimag(cres)**2
              ENDIF
              IF (imix.EQ.1.OR.imix.EQ.-2) then
                cresh=cres36(l,k,i,j)
                IF (imix.EQ.1) THEN
                  res=res+(dreal(cresh)**2+dimag(cresh)**2)*fatcor_hh
                ELSE IF (imix.EQ.-2) then
                  res=res+(cres*conjg(cresh)+cresh*conjg(cres))
     &              *fatcor_hz
                ENDIF
              ENDIF
              IF (iqu.EQ.1.AND.(imix.EQ.-1.or.imix.eq.-2)) then
                rc=2.d0/9.d0
                cres=(cres14(l,k,i,j)+cres16(l,k,i,j)+cres17(l,k,i,j)+
     &             cres20(l,k,i,j)+cres21(l,k,i,j)+cres27(l,k,i,j)+
     &             cres30(l,k,i,j)+cres33(l,k,i,j))/(f5l*fqdl)
                res=res+rc*(qcdcoupl**2)*(dreal(cres)**2+dimag(cres)**2)
     &            *
     &            fatcor_qcd
              ENDIF
            ENDDO !j
          ENDDO !i
        ENDDO !k
      ENDDO !l
* el1
      IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
        rc=9.d0
      ELSE IF ((i3q.EQ.1.AND.i5q.EQ.0).OR.(i5q.EQ.1.AND.i3q.EQ.0))THEN
        rc=3.d0
      ELSE 
        rc=1.d0
      ENDIF
* endel1
      ee_bbmumu=rc*res/p1k0/p2k0/p3k0/p4k0/p5k0/p6k0/4.d0

      IF (istrcor.EQ.1) THEN
        IF ((i3q.EQ.1.AND.i5q.EQ.0).OR.(i3q.EQ.0.AND.i5q.EQ.1))THEN
          ee_bbmumu=ee_bbmumu*(1.d0+qcdcor)
        ELSE IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
          ee_bbmumu=ee_bbmumu*(1.d0+qcdcor)**2
        ENDIF
      ENDIF

      RETURN
      END
