      REAL*8 FUNCTION ee_bbee(q1,q2,q3,q4,q5,q6)
* impulsi q1(0:3),q2(0:3),q3(0:3),q4(0:3),q5(0:3),q6(0:3)
* 1 e+, 2 e-, 3 b, 4 b~, 5 e-, 6 e~
* prendo per canale t tutti propagatori senza massa immaginaria
*
* flags:
*      common/iflag/icc,icc3,i3e,i4e,i3q,i5q,iqu,i34e,i56ve,iid,
*     &  imix,icoul,istrcor
* icc  =1 solo CC, 0 solo NC , -1 entrambi
*    se icc diverso da 0
* icc3 =1 solo CC3, 0 altrimenti
* i3e  =1 3 e' elettrone, 0 altrimenti
* i4e  =1 4 e' e+, 0 altrimenti
* i3q  =1 3 e' quark, 0 altrimenti
* i5q  =1 3 e' quark, 0 altrimenti
*    se icc diverso da 1
* iqu  =1 entrambi coppie di NC sono quark, 0 altrimenti
* i34e =1 coppia 3 e 4 sono elettroni, 0 altrimenti
* i56ve =1 coppia 56 sono neutrini elettrone , 0 altrimenti
* iid  =1 particelle identiche nello stato finale, 0 altrimenti
*
* imix= 2 somma cc +interferenza con nc, 1 solo cc (o Higgs), 0 solo
* interferenza tra cc e nc, -1 solo nc, -2 nc + interferenza con cc (o Higgs)
* ibbveve =1 se processo e' quello indicato, 0 altrimenti
*  serve per tener conto di massa del top a quadrato nel denominatore del
*  propagatore di cn28
*
*  struttura del programma:
****      vettori di polarizzazione ee gamma , eezeta
****  inizio NC
*        definizione vettori vet.k0 etc.
*        do ide=0,iid
*          if (iid.eq.1) then
*            p3<->p5
*            per rifare tutti i diagrammi con questo scambio per particelle id.
*          endif
****         24 diagrammi base di corrente neutra (6 per gamma e Z insieme)
*          if (iqu.eq.1) then
****         8 diagrammi di qcd (4)
*          endif
*          if (i34e.eq.1) then
****          24 con coppia 34 elettrone (6)
*          endif
*          if (i56ve.eq.1) then
****         diagrammi per correnti neutre con scambi di w (6)
*            if (i56ve.eq.1.and.iid.eq.1) then
****          diagrammi per correnti neutre con scambi di w (6) ottenuti da
****          quelli precedenti scambiando 56 con 34, necessari per 4 ve finali
*            endif
*          endif
*          if (iid.eq.1.and.i34e.eq.1) !anche 56 sono elettroni
*          !anche 56 sono elettroni
****          24 con coppia 56 elet.(come a i34.eq.1 con scambio coppie 35<->56)
*          endif
*        enddo
*       endif
**** fine NC
*
*  Nomenclatura per anomalous couplings
* e0 corrisponde a vettore di polarizzazione di gamma + zeta con coeff
*    opportuni, em a vettore di polarizzaz W-, ep a quello di W+
* p0 e' impulso uscente di gamma + zeta, pm quello di W-, pp quello di W+.
* Corrispondentemente ce0em e' prodotto scalare tra e0 e em, ce0pp e' prodotto
* scalare tra e0 e pp etc
      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT double COMPLEX (c)
      DIMENSION q1(0:3),q2(0:3),q3(0:3),q4(0:3),q5(0:3),q6(0:3)
      DIMENSION p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),p6(0:3)
      DIMENSION pau(0:3),p12(0:3),p34(0:3),p56(0:3), p123(0:3),
     &  p125(0:3),p134(0:3),p156(0:3),p345(0:3),p356(0:3)
      DIMENSION c34h(2,2)
      STRUCTURE/diag/
      double COMPLEX i(2)
      END STRUCTURE
      RECORD/diag/cn1(2,2,2,2,2,2),cn2(2,2,2,2,2,2),cn3(2,2,2,2,2,2),
     &  cn4(2,2,2,2,2,2),cn5(2,2,2,2,2,2),cn6(2,2,2,2,2,2)
     &  ,ch(2,2,2,2,2,2)
      STRUCTURE/polcom/
      double COMPLEX e(0:3),ek0,v
      END STRUCTURE
      RECORD/polcom/
     &  c12f(2),c12z(2),c34f(2,2),c34z(2,2),c56f(2),c56z(2)
      STRUCTURE/tu/
      double COMPLEX a(2),c(2)
      END STRUCTURE
      RECORD/tu/
     &  l1_34fz(2,2),l1_56fz(2),l5_12fz(2),l5_34fz(2,2)
      STRUCTURE/td/
      double COMPLEX a(2),b(2)
      END STRUCTURE
      RECORD/td/
     &  r2_34fz(2,2),r2_56fz(2),r6_12fz(2),r6_34fz(2,2)
      STRUCTURE/t/
      double COMPLEX a(2,2),b(2,2),c(2,2),d(2,2)
      END STRUCTURE
      RECORD/t/v34f(0:3),v34z(0:3),v34h,u3_12fz(2),u3_56fz(2),
     &  d4_56fz(2),d4_12fz(2),dia3(2,2),dia4(2,2)

      COMMON/abhigg/rmb,rmb2,rmh,rmh2,gamh,rhzz,rhww,rhbb
      COMMON/abparb/rmw2,gamw,rmz2,rmt2,rcotw,pi,alfa_me,qcdcoupl,
     &  qcdcor_cc,qcdcor_nc,qcdcor_h
      COMMON/abparc/czipr,ccz,cwipr,ccw,chipr,cch,caipr,cca
      COMMON/abcoup/fer,fel,zer,zel,f3l,f4l,f5l,f6l,z3l,z4l,z5l,z6l,
     &  f3r,f4r,f5r,f6r,z3r,z4r,z5r,z6r,wcl,delz,xf,xz,yf,yz,zz
      COMMON/abcopl/zvl,zvr,fqdl,fqdr,zqdl,zqdr,fqul,fqur,zqul,zqur
      COMMON/abflag/icc,icc3,i3e,i4e,i3q,i5q,iqu,i34e,i56ve,ibbveve,iid,
     &  imix,icoul,istrcor,idownl,idownr,ianc
*el2
     &  ,izz,izg,izg34,izg56,inc08,igamgam,itch
*endel2

      PARAMETER (czero=(0.d0,0.d0),cuno=(1.d0,0.d0),cim=(0.d0,1.d0))

      data ifirst /1/

* iset=1 grafici da 1 a 6 e segnale di higgs, iset=2 grafici da 17 a 22
*  e grafico di higgs corispondente.
*  I grafici del secondo set sono ottenuti dal primo tramite 1<->5

* impulsi p tutti uscenti, inoltre si passa tutti q a p per far scambi senza
*   danno
      DO m=0,3
        p1(m)=-q1(m)
        p2(m)=-q2(m)
        p3(m)=q3(m)
        p4(m)=q4(m)
        p5(m)=q5(m)
        p6(m)=q6(m)
      END DO
      DO iset=1,2
        IF (iset.EQ.2) THEN
          DO m=0,3
            pau(m)=p1(m)
            p1(m)=p5(m)
            p5(m)=pau(m)
          END DO
        ENDIF
* pk0 -- p=p1
        p1k0=p1(0)-p1(1)
* pk0 -- p=p2
        p2k0=p2(0)-p2(1)
* pk0 -- p=p3
        p3k0=p3(0)-p3(1)
* pk0 -- p=p4
        p4k0=p4(0)-p4(1)
* pk0 -- p=p5
        p5k0=p5(0)-p5(1)
* pk0 -- p=p6
        p6k0=p6(0)-p6(1)
*   Impulsi dei propagatori
        DO m=0,3
          p12(m)=p1(m)+p2(m)
          p34(m)=p3(m)+p4(m)
          p56(m)=p5(m)+p6(m)
          p123(m)=p12(m)+p3(m)
          p125(m)=p12(m)+p5(m)
          p134(m)=p1(m)+p34(m)
          p156(m)=p1(m)+p56(m)
          p345(m)=p34(m)+p5(m)
          p356(m)=p3(m)+p56(m)
        END DO
* pk0 -- p=p123
        p123k0=p123(0)-p123(1)
* p.q -- p.q=p123q,p=p123,q=p123,bef=,aft=
        p123q=(p123(0)*p123(0)-p123(1)*p123(1)-p123(2)*p123(2)-p12
     &    3(3)*p123(3))
* pk0 -- p=p125
        p125k0=p125(0)-p125(1)
* p.q -- p.q=p125q,p=p125,q=p125,bef=,aft=
        p125q=(p125(0)*p125(0)-p125(1)*p125(1)-p125(2)*p125(2)-p12
     &    5(3)*p125(3))
* pk0 -- p=p134
        p134k0=p134(0)-p134(1)
* p.q -- p.q=p134q,p=p134,q=p134,bef=,aft=
        p134q=(p134(0)*p134(0)-p134(1)*p134(1)-p134(2)*p134(2)-p13
     &    4(3)*p134(3))
* pk0 -- p=p156
        p156k0=p156(0)-p156(1)
* p.q -- p.q=p156q,p=p156,q=p156,bef=,aft=
        p156q=(p156(0)*p156(0)-p156(1)*p156(1)-p156(2)*p156(2)-p15
     &    6(3)*p156(3))
* pk0 -- p=p345
        p345k0=p345(0)-p345(1)
* p.q -- p.q=p345q,p=p345,q=p345,bef=,aft=
        p345q=(p345(0)*p345(0)-p345(1)*p345(1)-p345(2)*p345(2)-p34
     &    5(3)*p345(3))
* pk0 -- p=p356
        p356k0=p356(0)-p356(1)
* p.q -- p.q=p356q,p=p356,q=p356,bef=,aft=
        p356q=(p356(0)*p356(0)-p356(1)*p356(1)-p356(2)*p356(2)-p35
     &    6(3)*p356(3))
* p.q -- p.q=p12q,p=p12,q=p12,bef=,aft=
        p12q=(p12(0)*p12(0)-p12(1)*p12(1)-p12(2)*p12(2)-p12(3)*p12
     &    (3))
* p.q -- p.q=p34q,p=p34,q=p34,bef=,aft=
        p34q=(p34(0)*p34(0)-p34(1)*p34(1)-p34(2)*p34(2)-p34(3)*p34
     &    (3))
* p.q -- p.q=p56q,p=p56,q=p56,bef=,aft=
        p56q=(p56(0)*p56(0)-p56(1)*p56(1)-p56(2)*p56(2)-p56(3)*p56
     &    (3))
* vettori di polarizzazione e+e-
        quqd=p12q/2.d0
* il - qui e in cdw e' perche' i propagatori bosonici portano un segno -
* rispetto a quelli fermionici
        IF (iset.EQ.1)THEN
          cdz=-1.d0/(p12q*czipr-rmz2+ccz)
        ELSE
          cdz=-1.d0/(p12q-rmz2)
        ENDIF
        df=-1.d0/p12q
        fac1=(df*fer)
        fac2=(df*fel)
        cfac1z=(cdz*zer)/fac1
        cfac2z=(cdz*zel)/fac2
* T10 -- qu=p1,qd=p2,v=0,a=c12f(&).e(0),cr=fac1,cl=fac2,nsum=0
        eps_0=-p1(2)*p2(3)+p2(2)*p1(3)
        ceps_0=eps_0*cim
        auxa=-quqd+p1k0*p2(0)+p2k0*p1(0)
        c12f(1).e(0)=fac1*(auxa+ceps_0)
        c12f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=1,a=c12f(&).e(1),cr=fac1,cl=fac2,nsum=0
        auxa=-quqd+p1k0*p2(1)+p2k0*p1(1)
        c12f(1).e(1)=fac1*(auxa+ceps_0)
        c12f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=2,a=c12f(&).e(2),cr=fac1,cl=fac2,nsum=0
        eps_0=-p1k0*p2(3)+p2k0*p1(3)
        ceps_0=eps_0*cim
        auxa=p1k0*p2(2)+p2k0*p1(2)
        c12f(1).e(2)=fac1*(auxa+ceps_0)
        c12f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=3,a=c12f(&).e(3),cr=fac1,cl=fac2,nsum=0
        eps_0=p1k0*p2(2)-p2k0*p1(2)
        ceps_0=eps_0*cim
        auxa=p1k0*p2(3)+p2k0*p1(3)
        c12f(1).e(3)=fac1*(auxa+ceps_0)
        c12f(2).e(3)=fac2*(auxa-ceps_0)
        DO mu=0,3
          c12z(1).e(mu)=cfac1z*c12f(1).e(mu)
          c12z(2).e(mu)=cfac2z*c12f(2).e(mu)
        END DO
        DO i=1,2
* pk0 -- p=c12f(i).e
          c12f(i).ek0=c12f(i).e(0)-c12f(i).e(1)
        END DO
        DO i=1,2
* pk0 -- p=c12z(i).e
          c12z(i).ek0=c12z(i).e(0)-c12z(i).e(1)
        END DO
        quqd=p56q/2.d0
        df=-1.d0/p56q
        IF (iset.EQ.1)THEN
          cdz=-1.d0/(p56q*czipr-rmz2+ccz)
        ELSE
          cdz=-1.d0/(p56q-rmz2)
        ENDIF
        fac1=(df*fer)
        fac2=(df*fel)
        cfac1z=(cdz*zer)/fac1
        cfac2z=(cdz*zel)/fac2
* T10 -- qu=p5,qd=p6,v=0,a=c56f(&).e(0),cr=fac1,cl=fac2,nsum=0
        eps_0=-p5(2)*p6(3)+p6(2)*p5(3)
        ceps_0=eps_0*cim
        auxa=-quqd+p5k0*p6(0)+p6k0*p5(0)
        c56f(1).e(0)=fac1*(auxa+ceps_0)
        c56f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=1,a=c56f(&).e(1),cr=fac1,cl=fac2,nsum=0
        auxa=-quqd+p5k0*p6(1)+p6k0*p5(1)
        c56f(1).e(1)=fac1*(auxa+ceps_0)
        c56f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=2,a=c56f(&).e(2),cr=fac1,cl=fac2,nsum=0
        eps_0=-p5k0*p6(3)+p6k0*p5(3)
        ceps_0=eps_0*cim
        auxa=p5k0*p6(2)+p6k0*p5(2)
        c56f(1).e(2)=fac1*(auxa+ceps_0)
        c56f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=3,a=c56f(&).e(3),cr=fac1,cl=fac2,nsum=0
        eps_0=p5k0*p6(2)-p6k0*p5(2)
        ceps_0=eps_0*cim
        auxa=p5k0*p6(3)+p6k0*p5(3)
        c56f(1).e(3)=fac1*(auxa+ceps_0)
        c56f(2).e(3)=fac2*(auxa-ceps_0)
        DO mu=0,3
          c56z(1).e(mu)=cfac1z*c56f(1).e(mu)
          c56z(2).e(mu)=cfac2z*c56f(2).e(mu)
        END DO
        DO i=1,2
* pk0 -- p=c56f(i).e
          c56f(i).ek0=c56f(i).e(0)-c56f(i).e(1)
        END DO
        DO i=1,2
* pk0 -- p=c56z(i).e
          c56z(i).ek0=c56z(i).e(0)-c56z(i).e(1)
        END DO

        quqd=p34q/2.d0-rmb2
        df=-p34q
        cdz=-(p34q*czipr-rmz2+ccz)
* T -- qu=p3,qd=p4,v=0,a=v34f(0).a,b=v34f(0).b,c=v34f(0).c,d=v34f(0).d,cr=f
* qdr,cl=fqdl,nsum=0
        eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
        ceps_0=eps_0*cim
        ceps_1=p3(3)*cim
        ceps_2=p4(3)*cim
        auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
        v34f(0).a(1,1)=fqdr*(auxa+ceps_0)
        v34f(0).a(2,2)=fqdl*(auxa-ceps_0)
        v34f(0).b(1,2)=-fqdl*(p4(2)+ceps_2)
        v34f(0).b(2,1)=fqdr*(p4(2)-ceps_2)
        v34f(0).c(1,2)=fqdr*(p3(2)+ceps_1)
        v34f(0).c(2,1)=fqdl*(-p3(2)+ceps_1)
        v34f(0).d(1,1)=fqdl
        v34f(0).d(2,2)=fqdr
* T -- qu=p3,qd=p4,v=1,a=v34f(1).a,b=v34f(1).b,c=v34f(1).c,d=v34f(1).d,cr=f
* qdr,cl=fqdl,nsum=0
        auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
        v34f(1).a(1,1)=fqdr*(auxa+ceps_0)
        v34f(1).a(2,2)=fqdl*(auxa-ceps_0)
        v34f(1).b(1,2)=-fqdl*(p4(2)+ceps_2)
        v34f(1).b(2,1)=fqdr*(p4(2)-ceps_2)
        v34f(1).c(1,2)=fqdr*(p3(2)+ceps_1)
        v34f(1).c(2,1)=fqdl*(-p3(2)+ceps_1)
        v34f(1).d(1,1)=fqdl
        v34f(1).d(2,2)=fqdr
* T -- qu=p3,qd=p4,v=2,a=v34f(2).a,b=v34f(2).b,c=v34f(2).c,d=v34f(2).d,cr=f
* qdr,cl=fqdl,nsum=0
        eps_0=-p3k0*p4(3)+p4k0*p3(3)
        ceps_0=eps_0*cim
        auxa=p3k0*p4(2)+p4k0*p3(2)
        v34f(2).a(1,1)=fqdr*(auxa+ceps_0)
        v34f(2).a(2,2)=fqdl*(auxa-ceps_0)
        v34f(2).b(1,2)=-fqdl*p4k0
        v34f(2).b(2,1)=fqdr*p4k0
        v34f(2).c(1,2)=fqdr*p3k0
        v34f(2).c(2,1)=-fqdl*p3k0
* T -- qu=p3,qd=p4,v=3,a=v34f(3).a,b=v34f(3).b,c=v34f(3).c,d=v34f(3).d,cr=f
* qdr,cl=fqdl,nsum=0
        eps_0=p3k0*p4(2)-p4k0*p3(2)
        ceps_0=eps_0*cim
        ceps_1=p3k0*cim
        ceps_2=p4k0*cim
        auxa=+p3k0*p4(3)+p4k0*p3(3)
        v34f(3).a(1,1)=fqdr*(auxa+ceps_0)
        v34f(3).a(2,2)=fqdl*(auxa-ceps_0)
        v34f(3).b(1,2)=-fqdl*ceps_2
        v34f(3).b(2,1)=-fqdr*ceps_2
        v34f(3).c(1,2)=fqdr*ceps_1
        v34f(3).c(2,1)=fqdl*ceps_1
        DO m=0,3
* mline -- res=c34f(&1,&2).e(m),abcd=v34f(m).,m1=rmb,m2=(-rmb),den=df,nsum=
* 0
          DO iut=1,2
            DO jut=1,2
              c34f(iut,jut).e(m)=(v34f(m).a(iut,jut)+rmb*v34f(m).b(iut,j
     &          ut)+(-rmb)*v34f(m).c(iut,jut)+rmb*(-rmb)*v34f(m).d(iut,
     &          ju
     &          t))/df
            ENDDO
          ENDDO
        END DO
* T -- qu=p3,qd=p4,v=0,a=v34z(0).a,b=v34z(0).b,c=v34z(0).c,d=v34z(0).d,cr=z
* qdr,cl=zqdl,nsum=0
        eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
        ceps_0=eps_0*cim
        ceps_1=p3(3)*cim
        ceps_2=p4(3)*cim
        auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
        v34z(0).a(1,1)=zqdr*(auxa+ceps_0)
        v34z(0).a(2,2)=zqdl*(auxa-ceps_0)
        v34z(0).b(1,2)=-zqdl*(p4(2)+ceps_2)
        v34z(0).b(2,1)=zqdr*(p4(2)-ceps_2)
        v34z(0).c(1,2)=zqdr*(p3(2)+ceps_1)
        v34z(0).c(2,1)=zqdl*(-p3(2)+ceps_1)
        v34z(0).d(1,1)=zqdl
        v34z(0).d(2,2)=zqdr
* T -- qu=p3,qd=p4,v=1,a=v34z(1).a,b=v34z(1).b,c=v34z(1).c,d=v34z(1).d,cr=z
* qdr,cl=zqdl,nsum=0
        auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
        v34z(1).a(1,1)=zqdr*(auxa+ceps_0)
        v34z(1).a(2,2)=zqdl*(auxa-ceps_0)
        v34z(1).b(1,2)=-zqdl*(p4(2)+ceps_2)
        v34z(1).b(2,1)=zqdr*(p4(2)-ceps_2)
        v34z(1).c(1,2)=zqdr*(p3(2)+ceps_1)
        v34z(1).c(2,1)=zqdl*(-p3(2)+ceps_1)
        v34z(1).d(1,1)=zqdl
        v34z(1).d(2,2)=zqdr
* T -- qu=p3,qd=p4,v=2,a=v34z(2).a,b=v34z(2).b,c=v34z(2).c,d=v34z(2).d,cr=z
* qdr,cl=zqdl,nsum=0
        eps_0=-p3k0*p4(3)+p4k0*p3(3)
        ceps_0=eps_0*cim
        auxa=p3k0*p4(2)+p4k0*p3(2)
        v34z(2).a(1,1)=zqdr*(auxa+ceps_0)
        v34z(2).a(2,2)=zqdl*(auxa-ceps_0)
        v34z(2).b(1,2)=-zqdl*p4k0
        v34z(2).b(2,1)=zqdr*p4k0
        v34z(2).c(1,2)=zqdr*p3k0
        v34z(2).c(2,1)=-zqdl*p3k0
* T -- qu=p3,qd=p4,v=3,a=v34z(3).a,b=v34z(3).b,c=v34z(3).c,d=v34z(3).d,cr=z
* qdr,cl=zqdl,nsum=0
        eps_0=p3k0*p4(2)-p4k0*p3(2)
        ceps_0=eps_0*cim
        ceps_1=p3k0*cim
        ceps_2=p4k0*cim
        auxa=+p3k0*p4(3)+p4k0*p3(3)
        v34z(3).a(1,1)=zqdr*(auxa+ceps_0)
        v34z(3).a(2,2)=zqdl*(auxa-ceps_0)
        v34z(3).b(1,2)=-zqdl*ceps_2
        v34z(3).b(2,1)=-zqdr*ceps_2
        v34z(3).c(1,2)=zqdr*ceps_1
        v34z(3).c(2,1)=zqdl*ceps_1
        DO m=0,3
* mline -- res=c34z(&1,&2).e(m),abcd=v34z(m).,m1=rmb,m2=(-rmb),den=cdz,nsum
* =0
          DO iut=1,2
            DO jut=1,2
              c34z(iut,jut).e(m)=(v34z(m).a(iut,jut)+rmb*v34z(m).b(iut,j
     &          ut)+(-rmb)*v34z(m).c(iut,jut)+rmb*(-rmb)*v34z(m).d(iut,
     &          ju
     &          t))/cdz
            ENDDO
          ENDDO
        END DO
        DO i1=1,2
          DO i2=1,2
* pk0 -- p=c34f(i1,i2).e
            c34f(i1,i2).ek0=c34f(i1,i2).e(0)-c34f(i1,i2).e(1)
          END DO
        END DO
* aggiungo al propagatore della zeta pezzo prop. a k(mu)*k(nu)
        DO i1=1,2
          DO i2=1,2
* p.q -- p.q=caux,p=c34z(i1,i2).e,q=p34,bef=,aft=
            caux=(c34z(i1,i2).e(0)*p34(0)-c34z(i1,i2).e(1)*p34(1)-c34z
     &        (i1,i2).e(2)*p34(2)-c34z(i1,i2).e(3)*p34(3))
            DO m=0,3
              c34z(i1,i2).e(m)=c34z(i1,i2).e(m)-caux*p34(m)/rmz2
            END DO
          END DO
        END DO
        DO i1=1,2
          DO i2=1,2
* pk0 -- p=c34z(i1,i2).e
            c34z(i1,i2).ek0=c34z(i1,i2).e(0)-c34z(i1,i2).e(1)
          END DO
        END DO

*****attaccamento di  c12f(2) a 5
* quqd -- p=p5,q=p125
        quqd=p5(0)*p125(0)-p5(1)*p125(1)-p5(2)*p125(2)-p5(3)*p125(
     &    3)
        DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12f(i).e,a=l5_12fz(i).a,c=l5_12fz(i).c,cr=fer,cl=
* fel,nsum=0
          ceps_0=-c12f(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &      2f(i).e(2)*p125(3)-p125(2)*c12f(i).e(3))-p125k0*(c12f(i).
     &      e(2)*p5(3)-p5(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p5k0+p5(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c12f(i).e(0)*p5(0)-c12f(i).e(1)*p5(1)-c12f(i).e(2)*p5
     &      (2)-c12f(i).e(3)*p5(3)
          cvqd=c12f(i).e(0)*p125(0)-c12f(i).e(1)*p125(1)-c12f(i).e(2
     &      )*p125(2)-c12f(i).e(3)*p125(3)
          cauxa=-c12f(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
          cauxc=+c12f(i).ek0*p5(2)-p5k0*c12f(i).e(2)
          l5_12fz(i).a(1)=fer*(cauxa+ceps_0)
          l5_12fz(i).a(2)=fel*(cauxa-ceps_0)
          l5_12fz(i).c(1)=fer*(cauxc+ceps_1)
          l5_12fz(i).c(2)=fel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c12z(2) a 5
        DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12z(i).e,a=l5_12fz(i).a,c=l5_12fz(i).c,cr=zer,cl=
* zel,nsum=1
          ceps_0=-c12z(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &      2z(i).e(2)*p125(3)-p125(2)*c12z(i).e(3))-p125k0*(c12z(i).
     &      e(2)*p5(3)-p5(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p5k0+p5(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c12z(i).e(0)*p5(0)-c12z(i).e(1)*p5(1)-c12z(i).e(2)*p5
     &      (2)-c12z(i).e(3)*p5(3)
          cvqd=c12z(i).e(0)*p125(0)-c12z(i).e(1)*p125(1)-c12z(i).e(2
     &      )*p125(2)-c12z(i).e(3)*p125(3)
          cauxa=-c12z(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
          cauxc=+c12z(i).ek0*p5(2)-p5k0*c12z(i).e(2)
          l5_12fz(i).a(1)=l5_12fz(i).a(1)+zer*(cauxa+ceps_0)
          l5_12fz(i).a(2)=l5_12fz(i).a(2)+zel*(cauxa-ceps_0)
          l5_12fz(i).c(1)=l5_12fz(i).c(1)+zer*(cauxc+ceps_1)
          l5_12fz(i).c(2)=l5_12fz(i).c(2)+zel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c12f(2) a 6
* quqd -- p=p345,q=p6
        quqd=p345(0)*p6(0)-p345(1)*p6(1)-p345(2)*p6(2)-p345(3)*p6(
     &    3)
        DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12f(i).e,a=r6_12fz(i).a,b=r6_12fz(i).b,cr=fer,cl=
* fel,nsum=0
          ceps_0=-c12f(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &      c12f(i).e(2)*p6(3)-p6(2)*c12f(i).e(3))-p6k0*(c12f(i).e(2)
     &      *p345(3)-p345(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c12f(i).e(3)*p6k0+p6(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p345(0)-c12f(i).e(1)*p345(1)-c12f(i).e(2
     &      )*p345(2)-c12f(i).e(3)*p345(3)
          cvqd=c12f(i).e(0)*p6(0)-c12f(i).e(1)*p6(1)-c12f(i).e(2)*p6
     &      (2)-c12f(i).e(3)*p6(3)
          cauxa=-c12f(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
          cauxb=-c12f(i).ek0*p6(2)+p6k0*c12f(i).e(2)
          r6_12fz(i).a(1)=fer*(cauxa+ceps_0)
          r6_12fz(i).a(2)=fel*(cauxa-ceps_0)
          r6_12fz(i).b(1)=fel*(cauxb-ceps_2)
          r6_12fz(i).b(2)=fer*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c12z(2) a 6
        DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12z(i).e,a=r6_12fz(i).a,b=r6_12fz(i).b,cr=zer,cl=
* zel,nsum=1
          ceps_0=-c12z(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &      c12z(i).e(2)*p6(3)-p6(2)*c12z(i).e(3))-p6k0*(c12z(i).e(2)
     &      *p345(3)-p345(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c12z(i).e(3)*p6k0+p6(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p345(0)-c12z(i).e(1)*p345(1)-c12z(i).e(2
     &      )*p345(2)-c12z(i).e(3)*p345(3)
          cvqd=c12z(i).e(0)*p6(0)-c12z(i).e(1)*p6(1)-c12z(i).e(2)*p6
     &      (2)-c12z(i).e(3)*p6(3)
          cauxa=-c12z(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
          cauxb=-c12z(i).ek0*p6(2)+p6k0*c12z(i).e(2)
          r6_12fz(i).a(1)=r6_12fz(i).a(1)+zer*(cauxa+ceps_0)
          r6_12fz(i).a(2)=r6_12fz(i).a(2)+zel*(cauxa-ceps_0)
          r6_12fz(i).b(1)=r6_12fz(i).b(1)+zel*(cauxb-ceps_2)
          r6_12fz(i).b(2)=r6_12fz(i).b(2)+zer*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c56f(2) a 1 (e+)
* quqd -- p=p1,q=p156
        quqd=p1(0)*p156(0)-p1(1)*p156(1)-p1(2)*p156(2)-p1(3)*p156(
     &    3)
        DO i=1,2
* TL0 -- qu=p1,qd=p156,v=c56f(i).e,a=l1_56fz(i).a,c=l1_56fz(i).c,cr=fer,cl=
* fel,nsum=0
          ceps_0=-c56f(i).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c5
     &      6f(i).e(2)*p156(3)-p156(2)*c56f(i).e(3))-p156k0*(c56f(i).
     &      e(2)*p1(3)-p1(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p1k0+p1(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c56f(i).e(0)*p1(0)-c56f(i).e(1)*p1(1)-c56f(i).e(2)*p1
     &      (2)-c56f(i).e(3)*p1(3)
          cvqd=c56f(i).e(0)*p156(0)-c56f(i).e(1)*p156(1)-c56f(i).e(2
     &      )*p156(2)-c56f(i).e(3)*p156(3)
          cauxa=-c56f(i).ek0*quqd+p1k0*cvqd+p156k0*cvqu
          cauxc=+c56f(i).ek0*p1(2)-p1k0*c56f(i).e(2)
          l1_56fz(i).a(1)=fer*(cauxa+ceps_0)
          l1_56fz(i).a(2)=fel*(cauxa-ceps_0)
          l1_56fz(i).c(1)=fer*(cauxc+ceps_1)
          l1_56fz(i).c(2)=fel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c56z(2) a 1 (e+)
        DO i=1,2
* TL0 -- qu=p1,qd=p156,v=c56z(i).e,a=l1_56fz(i).a,c=l1_56fz(i).c,cr=zer,cl=
* zel,nsum=1
          ceps_0=-c56z(i).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c5
     &      6z(i).e(2)*p156(3)-p156(2)*c56z(i).e(3))-p156k0*(c56z(i).
     &      e(2)*p1(3)-p1(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p1k0+p1(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          cvqu=c56z(i).e(0)*p1(0)-c56z(i).e(1)*p1(1)-c56z(i).e(2)*p1
     &      (2)-c56z(i).e(3)*p1(3)
          cvqd=c56z(i).e(0)*p156(0)-c56z(i).e(1)*p156(1)-c56z(i).e(2
     &      )*p156(2)-c56z(i).e(3)*p156(3)
          cauxa=-c56z(i).ek0*quqd+p1k0*cvqd+p156k0*cvqu
          cauxc=+c56z(i).ek0*p1(2)-p1k0*c56z(i).e(2)
          l1_56fz(i).a(1)=l1_56fz(i).a(1)+zer*(cauxa+ceps_0)
          l1_56fz(i).a(2)=l1_56fz(i).a(2)+zel*(cauxa-ceps_0)
          l1_56fz(i).c(1)=l1_56fz(i).c(1)+zer*(cauxc+ceps_1)
          l1_56fz(i).c(2)=l1_56fz(i).c(2)+zel*(-cauxc+ceps_1)
        END DO
*****attaccamento di  c56f(2) a 2 (e-)
* quqd -- p=p134,q=p2
        quqd=p134(0)*p2(0)-p134(1)*p2(1)-p134(2)*p2(2)-p134(3)*p2(
     &    3)
        DO i1=1,2
* TR0 -- qu=p134,qd=p2,v=c56f(i1).e,a=r2_56fz(i1).a,b=r2_56fz(i1).b,cr=fer,
* cl=fel,nsum=0
          ceps_0=-c56f(i1).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*
     &      (c56f(i1).e(2)*p2(3)-p2(2)*c56f(i1).e(3))-p2k0*(c56f(i1).
     &      e(2)*p134(3)-p134(2)*c56f(i1).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c56f(i1).e(3)*p2k0+p2(3)*c56f(i1).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i1).e(0)*p134(0)-c56f(i1).e(1)*p134(1)-c56f(i1).
     &      e(2)*p134(2)-c56f(i1).e(3)*p134(3)
          cvqd=c56f(i1).e(0)*p2(0)-c56f(i1).e(1)*p2(1)-c56f(i1).e(2)
     &      *p2(2)-c56f(i1).e(3)*p2(3)
          cauxa=-c56f(i1).ek0*quqd+p134k0*cvqd+p2k0*cvqu
          cauxb=-c56f(i1).ek0*p2(2)+p2k0*c56f(i1).e(2)
          r2_56fz(i1).a(1)=fer*(cauxa+ceps_0)
          r2_56fz(i1).a(2)=fel*(cauxa-ceps_0)
          r2_56fz(i1).b(1)=fel*(cauxb-ceps_2)
          r2_56fz(i1).b(2)=fer*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c56z(2) a 2 (e-)
        DO i1=1,2
* TR0 -- qu=p134,qd=p2,v=c56z(i1).e,a=r2_56fz(i1).a,b=r2_56fz(i1).b,cr=zer,
* cl=zel,nsum=1
          ceps_0=-c56z(i1).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*
     &      (c56z(i1).e(2)*p2(3)-p2(2)*c56z(i1).e(3))-p2k0*(c56z(i1).
     &      e(2)*p134(3)-p134(2)*c56z(i1).e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c56z(i1).e(3)*p2k0+p2(3)*c56z(i1).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i1).e(0)*p134(0)-c56z(i1).e(1)*p134(1)-c56z(i1).
     &      e(2)*p134(2)-c56z(i1).e(3)*p134(3)
          cvqd=c56z(i1).e(0)*p2(0)-c56z(i1).e(1)*p2(1)-c56z(i1).e(2)
     &      *p2(2)-c56z(i1).e(3)*p2(3)
          cauxa=-c56z(i1).ek0*quqd+p134k0*cvqd+p2k0*cvqu
          cauxb=-c56z(i1).ek0*p2(2)+p2k0*c56z(i1).e(2)
          r2_56fz(i1).a(1)=r2_56fz(i1).a(1)+zer*(cauxa+ceps_0)
          r2_56fz(i1).a(2)=r2_56fz(i1).a(2)+zel*(cauxa-ceps_0)
          r2_56fz(i1).b(1)=r2_56fz(i1).b(1)+zel*(cauxb-ceps_2)
          r2_56fz(i1).b(2)=r2_56fz(i1).b(2)+zer*(-cauxb-ceps_2)
        END DO
*****attaccamento di  c34f(2,2) a 1 (e+)
* quqd -- p=p1,q=p134
        quqd=p1(0)*p134(0)-p1(1)*p134(1)-p1(2)*p134(2)-p1(3)*p134(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p1,qd=p134,v=c34f(i1,i2).e,a=l1_34fz(i1,i2).a,c=l1_34fz(i1,i2).
* c,cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0
     &        *(c34f(i1,i2).e(2)*p134(3)-p134(2)*c34f(i1,i2).e(3))-p134
     &        k0*(c34f(i1,i2).e(2)*p1(3)-p1(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i1,i2).e(3)*p1k0+p1(3)*c34f(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i1,i2).e(0)*p1(0)-c34f(i1,i2).e(1)*p1(1)-c34f(i1
     &        ,i2).e(2)*p1(2)-c34f(i1,i2).e(3)*p1(3)
            cvqd=c34f(i1,i2).e(0)*p134(0)-c34f(i1,i2).e(1)*p134(1)-c34
     &        f(i1,i2).e(2)*p134(2)-c34f(i1,i2).e(3)*p134(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34f(i1,i2).ek0*p1(2)-p1k0*c34f(i1,i2).e(2)
            l1_34fz(i1,i2).a(1)=fer*(cauxa+ceps_0)
            l1_34fz(i1,i2).a(2)=fel*(cauxa-ceps_0)
            l1_34fz(i1,i2).c(1)=fer*(cauxc+ceps_1)
            l1_34fz(i1,i2).c(2)=fel*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c34z(2,2) a 1 (e+)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p1,qd=p134,v=c34z(i1,i2).e,a=l1_34fz(i1,i2).a,c=l1_34fz(i1,i2).
* c,cr=zer,cl=zel,nsum=1
            ceps_0=-c34z(i1,i2).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0
     &        *(c34z(i1,i2).e(2)*p134(3)-p134(2)*c34z(i1,i2).e(3))-p134
     &        k0*(c34z(i1,i2).e(2)*p1(3)-p1(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i1,i2).e(3)*p1k0+p1(3)*c34z(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i1,i2).e(0)*p1(0)-c34z(i1,i2).e(1)*p1(1)-c34z(i1
     &        ,i2).e(2)*p1(2)-c34z(i1,i2).e(3)*p1(3)
            cvqd=c34z(i1,i2).e(0)*p134(0)-c34z(i1,i2).e(1)*p134(1)-c34
     &        z(i1,i2).e(2)*p134(2)-c34z(i1,i2).e(3)*p134(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34z(i1,i2).ek0*p1(2)-p1k0*c34z(i1,i2).e(2)
            l1_34fz(i1,i2).a(1)=l1_34fz(i1,i2).a(1)+zer*(cauxa+ceps_0)
            l1_34fz(i1,i2).a(2)=l1_34fz(i1,i2).a(2)+zel*(cauxa-ceps_0)
            l1_34fz(i1,i2).c(1)=l1_34fz(i1,i2).c(1)+zer*(cauxc+ceps_1)
            l1_34fz(i1,i2).c(2)=l1_34fz(i1,i2).c(2)+zel*(-cauxc+ceps_1
     &        )
          END DO
        END DO
*****attaccamento di  c34f(2) a 2 (e-)
* quqd -- p=p156,q=p2
        quqd=p156(0)*p2(0)-p156(1)*p2(1)-p156(2)*p2(2)-p156(3)*p2(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p156,qd=p2,v=c34f(i1,i2).e,a=r2_34fz(i1,i2).a,b=r2_34fz(i1,i2).
* b,cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156
     &        k0*(c34f(i1,i2).e(2)*p2(3)-p2(2)*c34f(i1,i2).e(3))-p2k0*(
     &        c34f(i1,i2).e(2)*p156(3)-p156(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i1,i2).e(3)*p2k0+p2(3)*c34f(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i1,i2).e(0)*p156(0)-c34f(i1,i2).e(1)*p156(1)-c34
     &        f(i1,i2).e(2)*p156(2)-c34f(i1,i2).e(3)*p156(3)
            cvqd=c34f(i1,i2).e(0)*p2(0)-c34f(i1,i2).e(1)*p2(1)-c34f(i1
     &        ,i2).e(2)*p2(2)-c34f(i1,i2).e(3)*p2(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34f(i1,i2).ek0*p2(2)+p2k0*c34f(i1,i2).e(2)
            r2_34fz(i1,i2).a(1)=fer*(cauxa+ceps_0)
            r2_34fz(i1,i2).a(2)=fel*(cauxa-ceps_0)
            r2_34fz(i1,i2).b(1)=fel*(cauxb-ceps_2)
            r2_34fz(i1,i2).b(2)=fer*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c34z(2) a 2 (e-)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p156,qd=p2,v=c34z(i1,i2).e,a=r2_34fz(i1,i2).a,b=r2_34fz(i1,i2).
* b,cr=zer,cl=zel,nsum=1
            ceps_0=-c34z(i1,i2).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156
     &        k0*(c34z(i1,i2).e(2)*p2(3)-p2(2)*c34z(i1,i2).e(3))-p2k0*(
     &        c34z(i1,i2).e(2)*p156(3)-p156(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i1,i2).e(3)*p2k0+p2(3)*c34z(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i1,i2).e(0)*p156(0)-c34z(i1,i2).e(1)*p156(1)-c34
     &        z(i1,i2).e(2)*p156(2)-c34z(i1,i2).e(3)*p156(3)
            cvqd=c34z(i1,i2).e(0)*p2(0)-c34z(i1,i2).e(1)*p2(1)-c34z(i1
     &        ,i2).e(2)*p2(2)-c34z(i1,i2).e(3)*p2(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34z(i1,i2).ek0*p2(2)+p2k0*c34z(i1,i2).e(2)
            r2_34fz(i1,i2).a(1)=r2_34fz(i1,i2).a(1)+zer*(cauxa+ceps_0)
            r2_34fz(i1,i2).a(2)=r2_34fz(i1,i2).a(2)+zel*(cauxa-ceps_0)
            r2_34fz(i1,i2).b(1)=r2_34fz(i1,i2).b(1)+zel*(cauxb-ceps_2)
            r2_34fz(i1,i2).b(2)=r2_34fz(i1,i2).b(2)+zer*(-cauxb-ceps_2
     &        )
          END DO
        END DO
*****attaccamento di  c34f a 5
* quqd -- p=p5,q=p345
        quqd=p5(0)*p345(0)-p5(1)*p345(1)-p5(2)*p345(2)-p5(3)*p345(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p5,qd=p345,v=c34f(i1,i2).e,a=l5_34fz(i1,i2).a,c=l5_34fz(i1,i2).
* c,cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0
     &        *(c34f(i1,i2).e(2)*p345(3)-p345(2)*c34f(i1,i2).e(3))-p345
     &        k0*(c34f(i1,i2).e(2)*p5(3)-p5(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i1,i2).e(3)*p5k0+p5(3)*c34f(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i1,i2).e(0)*p5(0)-c34f(i1,i2).e(1)*p5(1)-c34f(i1
     &        ,i2).e(2)*p5(2)-c34f(i1,i2).e(3)*p5(3)
            cvqd=c34f(i1,i2).e(0)*p345(0)-c34f(i1,i2).e(1)*p345(1)-c34
     &        f(i1,i2).e(2)*p345(2)-c34f(i1,i2).e(3)*p345(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34f(i1,i2).ek0*p5(2)-p5k0*c34f(i1,i2).e(2)
            l5_34fz(i1,i2).a(1)=fer*(cauxa+ceps_0)
            l5_34fz(i1,i2).a(2)=fel*(cauxa-ceps_0)
            l5_34fz(i1,i2).c(1)=fer*(cauxc+ceps_1)
            l5_34fz(i1,i2).c(2)=fel*(-cauxc+ceps_1)
          END DO
        END DO
*****attaccamento di  c34z a 5
        DO i1=1,2
          DO i2=1,2
* TL0 -- qu=p5,qd=p345,v=c34z(i1,i2).e,a=l5_34fz(i1,i2).a,c=l5_34fz(i1,i2).
* c,cr=zer,cl=zel,nsum=1
            ceps_0=-c34z(i1,i2).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0
     &        *(c34z(i1,i2).e(2)*p345(3)-p345(2)*c34z(i1,i2).e(3))-p345
     &        k0*(c34z(i1,i2).e(2)*p5(3)-p5(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i1,i2).e(3)*p5k0+p5(3)*c34z(i1,i2).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i1,i2).e(0)*p5(0)-c34z(i1,i2).e(1)*p5(1)-c34z(i1
     &        ,i2).e(2)*p5(2)-c34z(i1,i2).e(3)*p5(3)
            cvqd=c34z(i1,i2).e(0)*p345(0)-c34z(i1,i2).e(1)*p345(1)-c34
     &        z(i1,i2).e(2)*p345(2)-c34z(i1,i2).e(3)*p345(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34z(i1,i2).ek0*p5(2)-p5k0*c34z(i1,i2).e(2)
            l5_34fz(i1,i2).a(1)=l5_34fz(i1,i2).a(1)+zer*(cauxa+ceps_0)
            l5_34fz(i1,i2).a(2)=l5_34fz(i1,i2).a(2)+zel*(cauxa-ceps_0)
            l5_34fz(i1,i2).c(1)=l5_34fz(i1,i2).c(1)+zer*(cauxc+ceps_1)
            l5_34fz(i1,i2).c(2)=l5_34fz(i1,i2).c(2)+zel*(-cauxc+ceps_1
     &        )
          END DO
        END DO
*****attaccamento di  c34f a 6
* quqd -- p=p125,q=p6
        quqd=p125(0)*p6(0)-p125(1)*p6(1)-p125(2)*p6(2)-p125(3)*p6(
     &    3)
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p125,qd=p6,v=c34f(i1,i2).e,a=r6_34fz(i1,i2).a,b=r6_34fz(i1,i2).
* b,cr=fer,cl=fel,nsum=0
            ceps_0=-c34f(i1,i2).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125
     &        k0*(c34f(i1,i2).e(2)*p6(3)-p6(2)*c34f(i1,i2).e(3))-p6k0*(
     &        c34f(i1,i2).e(2)*p125(3)-p125(2)*c34f(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i1,i2).e(3)*p6k0+p6(3)*c34f(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i1,i2).e(0)*p125(0)-c34f(i1,i2).e(1)*p125(1)-c34
     &        f(i1,i2).e(2)*p125(2)-c34f(i1,i2).e(3)*p125(3)
            cvqd=c34f(i1,i2).e(0)*p6(0)-c34f(i1,i2).e(1)*p6(1)-c34f(i1
     &        ,i2).e(2)*p6(2)-c34f(i1,i2).e(3)*p6(3)
            cauxa=-c34f(i1,i2).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34f(i1,i2).ek0*p6(2)+p6k0*c34f(i1,i2).e(2)
            r6_34fz(i1,i2).a(1)=fer*(cauxa+ceps_0)
            r6_34fz(i1,i2).a(2)=fel*(cauxa-ceps_0)
            r6_34fz(i1,i2).b(1)=fel*(cauxb-ceps_2)
            r6_34fz(i1,i2).b(2)=fer*(-cauxb-ceps_2)
          END DO
        END DO
*****attaccamento di  c34z a 6
        DO i1=1,2
          DO i2=1,2
* TR0 -- qu=p125,qd=p6,v=c34z(i1,i2).e,a=r6_34fz(i1,i2).a,b=r6_34fz(i1,i2).
* b,cr=zer,cl=zel,nsum=1
            ceps_0=-c34z(i1,i2).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125
     &        k0*(c34z(i1,i2).e(2)*p6(3)-p6(2)*c34z(i1,i2).e(3))-p6k0*(
     &        c34z(i1,i2).e(2)*p125(3)-p125(2)*c34z(i1,i2).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i1,i2).e(3)*p6k0+p6(3)*c34z(i1,i2).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i1,i2).e(0)*p125(0)-c34z(i1,i2).e(1)*p125(1)-c34
     &        z(i1,i2).e(2)*p125(2)-c34z(i1,i2).e(3)*p125(3)
            cvqd=c34z(i1,i2).e(0)*p6(0)-c34z(i1,i2).e(1)*p6(1)-c34z(i1
     &        ,i2).e(2)*p6(2)-c34z(i1,i2).e(3)*p6(3)
            cauxa=-c34z(i1,i2).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34z(i1,i2).ek0*p6(2)+p6k0*c34z(i1,i2).e(2)
            r6_34fz(i1,i2).a(1)=r6_34fz(i1,i2).a(1)+zer*(cauxa+ceps_0)
            r6_34fz(i1,i2).a(2)=r6_34fz(i1,i2).a(2)+zel*(cauxa-ceps_0)
            r6_34fz(i1,i2).b(1)=r6_34fz(i1,i2).b(1)+zel*(cauxb-ceps_2)
            r6_34fz(i1,i2).b(2)=r6_34fz(i1,i2).b(2)+zer*(-cauxb-ceps_2
     &        )
          END DO
        END DO
*****attaccamento di  c12f(2) a 3 (b)
* quqd -- p=p3,q=p123
        quqd=p3(0)*p123(0)-p3(1)*p123(1)-p3(2)*p123(2)-p3(3)*p123(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p123,v=c12f(i).e,a=u3_12fz(i).a,b=u3_12fz(i).b,c=u3_12fz(i)
* .c,d=u3_12fz(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c12f(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &      2f(i).e(2)*p123(3)-p123(2)*c12f(i).e(3))-p123k0*(c12f(i).
     &      e(2)*p3(3)-p3(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p3k0+p3(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12f(i).e(3)*p123k0+p123(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p3(0)-c12f(i).e(1)*p3(1)-c12f(i).e(2)*p3
     &      (2)-c12f(i).e(3)*p3(3)
          cvqd=c12f(i).e(0)*p123(0)-c12f(i).e(1)*p123(1)-c12f(i).e(2
     &      )*p123(2)-c12f(i).e(3)*p123(3)
          cauxa=-c12f(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
          cauxb=-c12f(i).ek0*p123(2)+p123k0*c12f(i).e(2)
          cauxc=+c12f(i).ek0*p3(2)-p3k0*c12f(i).e(2)
          u3_12fz(i).a(1,1)=fqdr*(cauxa+ceps_0)
          u3_12fz(i).a(2,2)=fqdl*(cauxa-ceps_0)
          u3_12fz(i).b(1,2)=fqdl*(cauxb-ceps_2)
          u3_12fz(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          u3_12fz(i).c(1,2)=fqdr*(cauxc+ceps_1)
          u3_12fz(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          u3_12fz(i).d(1,1)=fqdl*c12f(i).ek0
          u3_12fz(i).d(2,2)=fqdr*c12f(i).ek0
        END DO
*****attaccamento di  c12z(2) a 3 (b)
        DO i=1,2
* T -- qu=p3,qd=p123,v=c12z(i).e,a=u3_12fz(i).a,b=u3_12fz(i).b,c=u3_12fz(i)
* .c,d=u3_12fz(i).d,cr=zqdr,cl=zqdl,nsum=1
          ceps_0=-c12z(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &      2z(i).e(2)*p123(3)-p123(2)*c12z(i).e(3))-p123k0*(c12z(i).
     &      e(2)*p3(3)-p3(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p3k0+p3(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12z(i).e(3)*p123k0+p123(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p3(0)-c12z(i).e(1)*p3(1)-c12z(i).e(2)*p3
     &      (2)-c12z(i).e(3)*p3(3)
          cvqd=c12z(i).e(0)*p123(0)-c12z(i).e(1)*p123(1)-c12z(i).e(2
     &      )*p123(2)-c12z(i).e(3)*p123(3)
          cauxa=-c12z(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
          cauxb=-c12z(i).ek0*p123(2)+p123k0*c12z(i).e(2)
          cauxc=+c12z(i).ek0*p3(2)-p3k0*c12z(i).e(2)
          u3_12fz(i).a(1,1)=u3_12fz(i).a(1,1)+zqdr*(cauxa+ceps_0)
          u3_12fz(i).a(2,2)=u3_12fz(i).a(2,2)+zqdl*(cauxa-ceps_0)
          u3_12fz(i).b(1,2)=u3_12fz(i).b(1,2)+zqdl*(cauxb-ceps_2)
          u3_12fz(i).b(2,1)=u3_12fz(i).b(2,1)+zqdr*(-cauxb-ceps_2)
          u3_12fz(i).c(1,2)=u3_12fz(i).c(1,2)+zqdr*(cauxc+ceps_1)
          u3_12fz(i).c(2,1)=u3_12fz(i).c(2,1)+zqdl*(-cauxc+ceps_1)
          u3_12fz(i).d(1,1)=u3_12fz(i).d(1,1)+zqdl*c12z(i).ek0
          u3_12fz(i).d(2,2)=u3_12fz(i).d(2,2)+zqdr*c12z(i).ek0
        END DO
*****attaccamento di  c12f(2) a 4 (bbar)
* quqd -- p=p356,q=p4
        quqd=p356(0)*p4(0)-p356(1)*p4(1)-p356(2)*p4(2)-p356(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p356,qd=p4,v=c12f(i).e,a=d4_12fz(i).a,b=d4_12fz(i).b,c=d4_12fz(i)
* .c,d=d4_12fz(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c12f(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &      c12f(i).e(2)*p4(3)-p4(2)*c12f(i).e(3))-p4k0*(c12f(i).e(2)
     &      *p356(3)-p356(2)*c12f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12f(i).e(3)*p356k0+p356(3)*c12f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12f(i).e(3)*p4k0+p4(3)*c12f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12f(i).e(0)*p356(0)-c12f(i).e(1)*p356(1)-c12f(i).e(2
     &      )*p356(2)-c12f(i).e(3)*p356(3)
          cvqd=c12f(i).e(0)*p4(0)-c12f(i).e(1)*p4(1)-c12f(i).e(2)*p4
     &      (2)-c12f(i).e(3)*p4(3)
          cauxa=-c12f(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
          cauxb=-c12f(i).ek0*p4(2)+p4k0*c12f(i).e(2)
          cauxc=+c12f(i).ek0*p356(2)-p356k0*c12f(i).e(2)
          d4_12fz(i).a(1,1)=fqdr*(cauxa+ceps_0)
          d4_12fz(i).a(2,2)=fqdl*(cauxa-ceps_0)
          d4_12fz(i).b(1,2)=fqdl*(cauxb-ceps_2)
          d4_12fz(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          d4_12fz(i).c(1,2)=fqdr*(cauxc+ceps_1)
          d4_12fz(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          d4_12fz(i).d(1,1)=fqdl*c12f(i).ek0
          d4_12fz(i).d(2,2)=fqdr*c12f(i).ek0
        END DO
*****attaccamento di  c12z(2) a 4 (bbar)
        DO i=1,2
* T -- qu=p356,qd=p4,v=c12z(i).e,a=d4_12fz(i).a,b=d4_12fz(i).b,c=d4_12fz(i)
* .c,d=d4_12fz(i).d,cr=zqdr,cl=zqdl,nsum=1
          ceps_0=-c12z(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &      c12z(i).e(2)*p4(3)-p4(2)*c12z(i).e(3))-p4k0*(c12z(i).e(2)
     &      *p356(3)-p356(2)*c12z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c12z(i).e(3)*p356k0+p356(3)*c12z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c12z(i).e(3)*p4k0+p4(3)*c12z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c12z(i).e(0)*p356(0)-c12z(i).e(1)*p356(1)-c12z(i).e(2
     &      )*p356(2)-c12z(i).e(3)*p356(3)
          cvqd=c12z(i).e(0)*p4(0)-c12z(i).e(1)*p4(1)-c12z(i).e(2)*p4
     &      (2)-c12z(i).e(3)*p4(3)
          cauxa=-c12z(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
          cauxb=-c12z(i).ek0*p4(2)+p4k0*c12z(i).e(2)
          cauxc=+c12z(i).ek0*p356(2)-p356k0*c12z(i).e(2)
          d4_12fz(i).a(1,1)=d4_12fz(i).a(1,1)+zqdr*(cauxa+ceps_0)
          d4_12fz(i).a(2,2)=d4_12fz(i).a(2,2)+zqdl*(cauxa-ceps_0)
          d4_12fz(i).b(1,2)=d4_12fz(i).b(1,2)+zqdl*(cauxb-ceps_2)
          d4_12fz(i).b(2,1)=d4_12fz(i).b(2,1)+zqdr*(-cauxb-ceps_2)
          d4_12fz(i).c(1,2)=d4_12fz(i).c(1,2)+zqdr*(cauxc+ceps_1)
          d4_12fz(i).c(2,1)=d4_12fz(i).c(2,1)+zqdl*(-cauxc+ceps_1)
          d4_12fz(i).d(1,1)=d4_12fz(i).d(1,1)+zqdl*c12z(i).ek0
          d4_12fz(i).d(2,2)=d4_12fz(i).d(2,2)+zqdr*c12z(i).ek0
        END DO
*****attaccamento di  c56f a 3
* quqd -- p=p3,q=p356
        quqd=p3(0)*p356(0)-p3(1)*p356(1)-p3(2)*p356(2)-p3(3)*p356(
     &    3)
        DO i=1,2
* T -- qu=p3,qd=p356,v=c56f(i).e,a=u3_56fz(i).a,b=u3_56fz(i).b,c=u3_56fz(i)
* .c,d=u3_56fz(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c56f(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &      6f(i).e(2)*p356(3)-p356(2)*c56f(i).e(3))-p356k0*(c56f(i).
     &      e(2)*p3(3)-p3(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p3k0+p3(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56f(i).e(3)*p356k0+p356(3)*c56f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i).e(0)*p3(0)-c56f(i).e(1)*p3(1)-c56f(i).e(2)*p3
     &      (2)-c56f(i).e(3)*p3(3)
          cvqd=c56f(i).e(0)*p356(0)-c56f(i).e(1)*p356(1)-c56f(i).e(2
     &      )*p356(2)-c56f(i).e(3)*p356(3)
          cauxa=-c56f(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
          cauxb=-c56f(i).ek0*p356(2)+p356k0*c56f(i).e(2)
          cauxc=+c56f(i).ek0*p3(2)-p3k0*c56f(i).e(2)
          u3_56fz(i).a(1,1)=fqdr*(cauxa+ceps_0)
          u3_56fz(i).a(2,2)=fqdl*(cauxa-ceps_0)
          u3_56fz(i).b(1,2)=fqdl*(cauxb-ceps_2)
          u3_56fz(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          u3_56fz(i).c(1,2)=fqdr*(cauxc+ceps_1)
          u3_56fz(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          u3_56fz(i).d(1,1)=fqdl*c56f(i).ek0
          u3_56fz(i).d(2,2)=fqdr*c56f(i).ek0
        END DO
*****attaccamento di  c56z a 3
        DO i=1,2
* T -- qu=p3,qd=p356,v=c56z(i).e,a=u3_56fz(i).a,b=u3_56fz(i).b,c=u3_56fz(i)
* .c,d=u3_56fz(i).d,cr=zqdr,cl=zqdl,nsum=1
          ceps_0=-c56z(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &      6z(i).e(2)*p356(3)-p356(2)*c56z(i).e(3))-p356k0*(c56z(i).
     &      e(2)*p3(3)-p3(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p3k0+p3(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56z(i).e(3)*p356k0+p356(3)*c56z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i).e(0)*p3(0)-c56z(i).e(1)*p3(1)-c56z(i).e(2)*p3
     &      (2)-c56z(i).e(3)*p3(3)
          cvqd=c56z(i).e(0)*p356(0)-c56z(i).e(1)*p356(1)-c56z(i).e(2
     &      )*p356(2)-c56z(i).e(3)*p356(3)
          cauxa=-c56z(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
          cauxb=-c56z(i).ek0*p356(2)+p356k0*c56z(i).e(2)
          cauxc=+c56z(i).ek0*p3(2)-p3k0*c56z(i).e(2)
          u3_56fz(i).a(1,1)=u3_56fz(i).a(1,1)+zqdr*(cauxa+ceps_0)
          u3_56fz(i).a(2,2)=u3_56fz(i).a(2,2)+zqdl*(cauxa-ceps_0)
          u3_56fz(i).b(1,2)=u3_56fz(i).b(1,2)+zqdl*(cauxb-ceps_2)
          u3_56fz(i).b(2,1)=u3_56fz(i).b(2,1)+zqdr*(-cauxb-ceps_2)
          u3_56fz(i).c(1,2)=u3_56fz(i).c(1,2)+zqdr*(cauxc+ceps_1)
          u3_56fz(i).c(2,1)=u3_56fz(i).c(2,1)+zqdl*(-cauxc+ceps_1)
          u3_56fz(i).d(1,1)=u3_56fz(i).d(1,1)+zqdl*c56z(i).ek0
          u3_56fz(i).d(2,2)=u3_56fz(i).d(2,2)+zqdr*c56z(i).ek0
        END DO
*****attaccamento di  c56f a 4
* quqd -- p=p123,q=p4
        quqd=p123(0)*p4(0)-p123(1)*p4(1)-p123(2)*p4(2)-p123(3)*p4(
     &    3)
        DO i=1,2
* T -- qu=p123,qd=p4,v=c56f(i).e,a=d4_56fz(i).a,b=d4_56fz(i).b,c=d4_56fz(i)
* .c,d=d4_56fz(i).d,cr=fqdr,cl=fqdl,nsum=0
          ceps_0=-c56f(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &      c56f(i).e(2)*p4(3)-p4(2)*c56f(i).e(3))-p4k0*(c56f(i).e(2)
     &      *p123(3)-p123(2)*c56f(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56f(i).e(3)*p123k0+p123(3)*c56f(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56f(i).e(3)*p4k0+p4(3)*c56f(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56f(i).e(0)*p123(0)-c56f(i).e(1)*p123(1)-c56f(i).e(2
     &      )*p123(2)-c56f(i).e(3)*p123(3)
          cvqd=c56f(i).e(0)*p4(0)-c56f(i).e(1)*p4(1)-c56f(i).e(2)*p4
     &      (2)-c56f(i).e(3)*p4(3)
          cauxa=-c56f(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
          cauxb=-c56f(i).ek0*p4(2)+p4k0*c56f(i).e(2)
          cauxc=+c56f(i).ek0*p123(2)-p123k0*c56f(i).e(2)
          d4_56fz(i).a(1,1)=fqdr*(cauxa+ceps_0)
          d4_56fz(i).a(2,2)=fqdl*(cauxa-ceps_0)
          d4_56fz(i).b(1,2)=fqdl*(cauxb-ceps_2)
          d4_56fz(i).b(2,1)=fqdr*(-cauxb-ceps_2)
          d4_56fz(i).c(1,2)=fqdr*(cauxc+ceps_1)
          d4_56fz(i).c(2,1)=fqdl*(-cauxc+ceps_1)
          d4_56fz(i).d(1,1)=fqdl*c56f(i).ek0
          d4_56fz(i).d(2,2)=fqdr*c56f(i).ek0
        END DO
*****attaccamento di  c56z a 4
        DO i=1,2
* T -- qu=p123,qd=p4,v=c56z(i).e,a=d4_56fz(i).a,b=d4_56fz(i).b,c=d4_56fz(i)
* .c,d=d4_56fz(i).d,cr=zqdr,cl=zqdl,nsum=1
          ceps_0=-c56z(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &      c56z(i).e(2)*p4(3)-p4(2)*c56z(i).e(3))-p4k0*(c56z(i).e(2)
     &      *p123(3)-p123(2)*c56z(i).e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c56z(i).e(3)*p123k0+p123(3)*c56z(i).ek0
          ceps_1=ceps_1*cim
          ceps_2=-c56z(i).e(3)*p4k0+p4(3)*c56z(i).ek0
          ceps_2=ceps_2*cim
          cvqu=c56z(i).e(0)*p123(0)-c56z(i).e(1)*p123(1)-c56z(i).e(2
     &      )*p123(2)-c56z(i).e(3)*p123(3)
          cvqd=c56z(i).e(0)*p4(0)-c56z(i).e(1)*p4(1)-c56z(i).e(2)*p4
     &      (2)-c56z(i).e(3)*p4(3)
          cauxa=-c56z(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
          cauxb=-c56z(i).ek0*p4(2)+p4k0*c56z(i).e(2)
          cauxc=+c56z(i).ek0*p123(2)-p123k0*c56z(i).e(2)
          d4_56fz(i).a(1,1)=d4_56fz(i).a(1,1)+zqdr*(cauxa+ceps_0)
          d4_56fz(i).a(2,2)=d4_56fz(i).a(2,2)+zqdl*(cauxa-ceps_0)
          d4_56fz(i).b(1,2)=d4_56fz(i).b(1,2)+zqdl*(cauxb-ceps_2)
          d4_56fz(i).b(2,1)=d4_56fz(i).b(2,1)+zqdr*(-cauxb-ceps_2)
          d4_56fz(i).c(1,2)=d4_56fz(i).c(1,2)+zqdr*(cauxc+ceps_1)
          d4_56fz(i).c(2,1)=d4_56fz(i).c(2,1)+zqdl*(-cauxc+ceps_1)
          d4_56fz(i).d(1,1)=d4_56fz(i).d(1,1)+zqdl*c56z(i).ek0
          d4_56fz(i).d(2,2)=d4_56fz(i).d(2,2)+zqdr*c56z(i).ek0
        END DO

**************arrivato qui bisogna decidere quanti indici usare
**** Diagramma CN1 ****
        DO i3=1,2
          DO i4=1,2
            DO i5=1,2
* TLTR0 -- aa=cn1(&,&,i3,i4,i5,i5).i(iset),a1=l1_34fz(i3,i4).a,c1=l1_34fz(i
* 3,i4).c,a2=r2_56fz(i5).a,b2=r2_56fz(i5).b,prq=p134q,bef=,aft=/(p134q*p134k
* 0)
              cn1(1,1,i3,i4,i5,i5).i(iset)=(l1_34fz(i3,i4).a(1)*r2_56fz(
     &          i5).a(1)+l1_34fz(i3,i4).c(1)*p134q*r2_56fz(i5).b(2))
     &          /(p13
     &          4q*p134k0)
              cn1(2,2,i3,i4,i5,i5).i(iset)=(l1_34fz(i3,i4).c(2)*p134q*r2
     &          _56fz(i5).b(1)+l1_34fz(i3,i4).a(2)*r2_56fz(i5).a(2))
     &          /(p13
     &          4q*p134k0)
            END DO
          END DO
        END DO
**** Diagramma CN2 ****
        DO i3=1,2
          DO i4=1,2
            DO i5=1,2
* TLTR0 -- aa=cn2(&,&,i3,i4,i5,i5).i(iset),a1=l1_56fz(i5).a,c1=l1_56fz(i5).
* c,a2=r2_34fz(i3,i4).a,b2=r2_34fz(i3,i4).b,prq=p156q,bef=,aft=/(p156q*p156k
* 0)
              cn2(1,1,i3,i4,i5,i5).i(iset)=(l1_56fz(i5).a(1)*r2_34fz(i3,
     &          i4).a(1)+l1_56fz(i5).c(1)*p156q*r2_34fz(i3,i4).b(2))
     &          /(p15
     &          6q*p156k0)
              cn2(2,2,i3,i4,i5,i5).i(iset)=(l1_56fz(i5).c(2)*p156q*r2_34
     &          fz(i3,i4).b(1)+l1_56fz(i5).a(2)*r2_34fz(i3,i4).a(2))
     &          /(p15
     &          6q*p156k0)
            END DO
          END DO
        END DO
**** Diagramma CN3 ****
        DO i1=1,2
          DO i5=1,2
* TT -- aa=dia3(i1,i5).a,bb=dia3(i1,i5).b,cc=dia3(i1,i5).c,dd=dia3(i1,i5).d
* ,a1=u3_56fz(i5).a,b1=u3_56fz(i5).b,c1=u3_56fz(i5).c,d1=u3_56fz(i5).d,a2=d4
* _12fz(i1).a,b2=d4_12fz(i1).b,c2=d4_12fz(i1).c,d2=d4_12fz(i1).d,prq=p356q,m
* =rmb,nsum=0
            dia3(i1,i5).a(1,1)=u3_56fz(i5).a(1,1)*d4_12fz(i1).a(1,1)+u
     &        3_56fz(i5).c(1,2)*p356q*d4_12fz(i1).b(2,1)
            dia3(i1,i5).b(1,1)=rmb*(u3_56fz(i5).d(1,1)*d4_12fz(i1).a(1
     &        ,1)+u3_56fz(i5).b(1,2)*d4_12fz(i1).b(2,1))
            dia3(i1,i5).c(1,1)=rmb*(u3_56fz(i5).a(1,1)*d4_12fz(i1).d(1
     &        ,1)+u3_56fz(i5).c(1,2)*d4_12fz(i1).c(2,1))
            dia3(i1,i5).d(1,1)=u3_56fz(i5).d(1,1)*p356q*d4_12fz(i1).d(
     &        1,1)+u3_56fz(i5).b(1,2)*d4_12fz(i1).c(2,1)
            dia3(i1,i5).a(1,2)=rmb*(u3_56fz(i5).a(1,1)*d4_12fz(i1).b(1
     &        ,2)+u3_56fz(i5).c(1,2)*d4_12fz(i1).a(2,2))
            dia3(i1,i5).b(1,2)=u3_56fz(i5).d(1,1)*p356q*d4_12fz(i1).b(
     &        1,2)+u3_56fz(i5).b(1,2)*d4_12fz(i1).a(2,2)
            dia3(i1,i5).c(1,2)=u3_56fz(i5).a(1,1)*d4_12fz(i1).c(1,2)+u
     &        3_56fz(i5).c(1,2)*p356q*d4_12fz(i1).d(2,2)
            dia3(i1,i5).d(1,2)=rmb*(u3_56fz(i5).d(1,1)*d4_12fz(i1).c(1
     &        ,2)+u3_56fz(i5).b(1,2)*d4_12fz(i1).d(2,2))
            dia3(i1,i5).a(2,1)=rmb*(u3_56fz(i5).c(2,1)*d4_12fz(i1).a(1
     &        ,1)+u3_56fz(i5).a(2,2)*d4_12fz(i1).b(2,1))
            dia3(i1,i5).b(2,1)=u3_56fz(i5).b(2,1)*d4_12fz(i1).a(1,1)+u
     &        3_56fz(i5).d(2,2)*p356q*d4_12fz(i1).b(2,1)
            dia3(i1,i5).c(2,1)=u3_56fz(i5).c(2,1)*p356q*d4_12fz(i1).d(
     &        1,1)+u3_56fz(i5).a(2,2)*d4_12fz(i1).c(2,1)
            dia3(i1,i5).d(2,1)=rmb*(u3_56fz(i5).b(2,1)*d4_12fz(i1).d(1
     &        ,1)+u3_56fz(i5).d(2,2)*d4_12fz(i1).c(2,1))
            dia3(i1,i5).a(2,2)=u3_56fz(i5).c(2,1)*p356q*d4_12fz(i1).b(
     &        1,2)+u3_56fz(i5).a(2,2)*d4_12fz(i1).a(2,2)
            dia3(i1,i5).b(2,2)=rmb*(u3_56fz(i5).b(2,1)*d4_12fz(i1).b(1
     &        ,2)+u3_56fz(i5).d(2,2)*d4_12fz(i1).a(2,2))
            dia3(i1,i5).c(2,2)=rmb*(u3_56fz(i5).c(2,1)*d4_12fz(i1).c(1
     &        ,2)+u3_56fz(i5).a(2,2)*d4_12fz(i1).d(2,2))
            dia3(i1,i5).d(2,2)=u3_56fz(i5).b(2,1)*d4_12fz(i1).c(1,2)+u
     &        3_56fz(i5).d(2,2)*p356q*d4_12fz(i1).d(2,2)
          END DO
        END DO
        DO i1=1,2
          DO i5=1,2
* mline -- res=cn3(i1,i1,&1,&2,i5,i5).i(iset),abcd=dia3(i1,i5).,m1=rmb,m2=(
* -rmb),den=((p356q-rmb2)*p356k0),nsum=0
            DO iut=1,2
              DO jut=1,2
                cn3(i1,i1,iut,jut,i5,i5).i(iset)=(dia3(i1,i5).a(iut,jut)
     &            +r
     &            mb*dia3(i1,i5).b(iut,jut)+(-rmb)*dia3(i1,i5).c(iut,
     &            jut)+r
     &            mb*(-rmb)*dia3(i1,i5).d(iut,jut))/((p356q-rmb2)
     &            *p356k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma CN4 ****
        DO i1=1,2
          DO i5=1,2
* TT -- aa=dia4(i1,i5).a,bb=dia4(i1,i5).b,cc=dia4(i1,i5).c,dd=dia4(i1,i5).d
* ,a1=u3_12fz(i1).a,b1=u3_12fz(i1).b,c1=u3_12fz(i1).c,d1=u3_12fz(i1).d,a2=d4
* _56fz(i5).a,b2=d4_56fz(i5).b,c2=d4_56fz(i5).c,d2=d4_56fz(i5).d,prq=p123q,m
* =rmb,nsum=0
            dia4(i1,i5).a(1,1)=u3_12fz(i1).a(1,1)*d4_56fz(i5).a(1,1)+u
     &        3_12fz(i1).c(1,2)*p123q*d4_56fz(i5).b(2,1)
            dia4(i1,i5).b(1,1)=rmb*(u3_12fz(i1).d(1,1)*d4_56fz(i5).a(1
     &        ,1)+u3_12fz(i1).b(1,2)*d4_56fz(i5).b(2,1))
            dia4(i1,i5).c(1,1)=rmb*(u3_12fz(i1).a(1,1)*d4_56fz(i5).d(1
     &        ,1)+u3_12fz(i1).c(1,2)*d4_56fz(i5).c(2,1))
            dia4(i1,i5).d(1,1)=u3_12fz(i1).d(1,1)*p123q*d4_56fz(i5).d(
     &        1,1)+u3_12fz(i1).b(1,2)*d4_56fz(i5).c(2,1)
            dia4(i1,i5).a(1,2)=rmb*(u3_12fz(i1).a(1,1)*d4_56fz(i5).b(1
     &        ,2)+u3_12fz(i1).c(1,2)*d4_56fz(i5).a(2,2))
            dia4(i1,i5).b(1,2)=u3_12fz(i1).d(1,1)*p123q*d4_56fz(i5).b(
     &        1,2)+u3_12fz(i1).b(1,2)*d4_56fz(i5).a(2,2)
            dia4(i1,i5).c(1,2)=u3_12fz(i1).a(1,1)*d4_56fz(i5).c(1,2)+u
     &        3_12fz(i1).c(1,2)*p123q*d4_56fz(i5).d(2,2)
            dia4(i1,i5).d(1,2)=rmb*(u3_12fz(i1).d(1,1)*d4_56fz(i5).c(1
     &        ,2)+u3_12fz(i1).b(1,2)*d4_56fz(i5).d(2,2))
            dia4(i1,i5).a(2,1)=rmb*(u3_12fz(i1).c(2,1)*d4_56fz(i5).a(1
     &        ,1)+u3_12fz(i1).a(2,2)*d4_56fz(i5).b(2,1))
            dia4(i1,i5).b(2,1)=u3_12fz(i1).b(2,1)*d4_56fz(i5).a(1,1)+u
     &        3_12fz(i1).d(2,2)*p123q*d4_56fz(i5).b(2,1)
            dia4(i1,i5).c(2,1)=u3_12fz(i1).c(2,1)*p123q*d4_56fz(i5).d(
     &        1,1)+u3_12fz(i1).a(2,2)*d4_56fz(i5).c(2,1)
            dia4(i1,i5).d(2,1)=rmb*(u3_12fz(i1).b(2,1)*d4_56fz(i5).d(1
     &        ,1)+u3_12fz(i1).d(2,2)*d4_56fz(i5).c(2,1))
            dia4(i1,i5).a(2,2)=u3_12fz(i1).c(2,1)*p123q*d4_56fz(i5).b(
     &        1,2)+u3_12fz(i1).a(2,2)*d4_56fz(i5).a(2,2)
            dia4(i1,i5).b(2,2)=rmb*(u3_12fz(i1).b(2,1)*d4_56fz(i5).b(1
     &        ,2)+u3_12fz(i1).d(2,2)*d4_56fz(i5).a(2,2))
            dia4(i1,i5).c(2,2)=rmb*(u3_12fz(i1).c(2,1)*d4_56fz(i5).c(1
     &        ,2)+u3_12fz(i1).a(2,2)*d4_56fz(i5).d(2,2))
            dia4(i1,i5).d(2,2)=u3_12fz(i1).b(2,1)*d4_56fz(i5).c(1,2)+u
     &        3_12fz(i1).d(2,2)*p123q*d4_56fz(i5).d(2,2)
          END DO
        END DO
        DO i1=1,2
          DO i5=1,2
* mline -- res=cn4(i1,i1,&1,&2,i5,i5).i(iset),abcd=dia4(i1,i5).,m1=rmb,m2=(
* -rmb),den=((p123q-rmb2)*p123k0),nsum=0
            DO iut=1,2
              DO jut=1,2
                cn4(i1,i1,iut,jut,i5,i5).i(iset)=(dia4(i1,i5).a(iut,jut)
     &            +r
     &            mb*dia4(i1,i5).b(iut,jut)+(-rmb)*dia4(i1,i5).c(iut,
     &            jut)+r
     &            mb*(-rmb)*dia4(i1,i5).d(iut,jut))/((p123q-rmb2)
     &            *p123k0)
              ENDDO
            ENDDO
          END DO
        END DO
**** Diagramma CN5 ****
        DO i1=1,2
          DO i3=1,2
            DO i4=1,2
* TLTR0 -- aa=cn5(i1,i1,i3,i4,&,&).i(iset),a1=l5_34fz(i3,i4).a,c1=l5_34fz(i
* 3,i4).c,a2=r6_12fz(i1).a,b2=r6_12fz(i1).b,prq=p345q,bef=,aft=/(p345q*p345k
* 0)
              cn5(i1,i1,i3,i4,1,1).i(iset)=(l5_34fz(i3,i4).a(1)*r6_12fz(
     &          i1).a(1)+l5_34fz(i3,i4).c(1)*p345q*r6_12fz(i1).b(2))
     &          /(p34
     &          5q*p345k0)
              cn5(i1,i1,i3,i4,2,2).i(iset)=(l5_34fz(i3,i4).c(2)*p345q*r6
     &          _12fz(i1).b(1)+l5_34fz(i3,i4).a(2)*r6_12fz(i1).a(2))
     &          /(p34
     &          5q*p345k0)
            END DO
          END DO
        END DO
**** Diagramma CN6 ****
        DO i1=1,2
          DO i3=1,2
            DO i4=1,2
* TLTR0 -- aa=cn6(i1,i1,i3,i4,&,&).i(iset),a1=l5_12fz(i1).a,c1=l5_12fz(i1).
* c,a2=r6_34fz(i3,i4).a,b2=r6_34fz(i3,i4).b,prq=p125q,bef=,aft=/(p125q*p125k
* 0)
              cn6(i1,i1,i3,i4,1,1).i(iset)=(l5_12fz(i1).a(1)*r6_34fz(i3,
     &          i4).a(1)+l5_12fz(i1).c(1)*p125q*r6_34fz(i3,i4).b(2))
     &          /(p12
     &          5q*p125k0)
              cn6(i1,i1,i3,i4,2,2).i(iset)=(l5_12fz(i1).c(2)*p125q*r6_34
     &          fz(i3,i4).b(1)+l5_12fz(i1).a(2)*r6_34fz(i3,i4).a(2))
     &          /(p12
     &          5q*p125k0)
            END DO
          END DO
        END DO
*  Introduco l' Higgs
        IF (imix.EQ.1.OR.imix.EQ.-2) then
*        Diagramma    segnale di Higgs
* Vertice b b~ H ( quarks massivi )
* quqd -- p=p3,q=p4
          quqd=p3(0)*p4(0)-p3(1)*p4(1)-p3(2)*p4(2)-p3(3)*p4(3)
          cdh=-(2.d0*(quqd+rmb2)*chipr-rmh2+cch)
* TH -- qu=p3,qd=p4,a=v34h.a,b=v34h.b,c=v34h.c
          v34h.a(1,2)=-p3k0*p4(2)+p4k0*p3(2)-cim*(p4(3)*p3k0-p3(3)*p
     &      4k0)
          v34h.a(2,1)=-conjg(v34h.a(1,2))
          v34h.b(1,1)=p4k0
          v34h.b(2,2)=v34h.b(1,1)
          v34h.c(1,1)=p3k0
          v34h.c(2,2)=v34h.c(1,1)
* mline -- res=c34h(&1,&2),abcd=v34h.,m1=rmb,m2=(-rmb),den=cdh,nsum=0
          DO iut=1,2
            DO jut=1,2
              c34h(iut,jut)=(v34h.a(iut,jut)+rmb*v34h.b(iut,jut)+(-rmb)*
     &          v34h.c(iut,jut)+rmb*(-rmb)*v34h.d(iut,jut))/cdh
            ENDDO
          ENDDO
          DO i1=1,2
            DO i3=1,2
              DO i4=1,2
                DO i5=1,2
                  ch(i1,i1,i3,i4,i5,i5).i(iset)=rhzz*
     &              (c56z(i5).e(0)*c12z(i1).e(0)-
     &              c56z(i5).e(1)*c12z(i1).e(1)-c56z(i5).e(2)*
     &              c12z(i1).e(2)-c56z(i5).e(3)*c12z(i1).e(3))*c34h(i3,
     &              i4)
                ENDDO !i5
              ENDDO !i4
            ENDDO !i3
          ENDDO !i1

        ENDIF

      END DO  !iset


**************************somma grafici*****************************

      if (ifirst.eq.1) then
        IF(istrcor.EQ.1)THEN
          fatcor_hh=(1.d0+qcdcor_h)/(1.d0+qcdcor_nc)
          fatcor_hz=sqrt((1.d0+qcdcor_nc)*(1.d0+qcdcor_h))
     &      /(1.d0+qcdcor_nc)
        ELSE
          fatcor_hh=1.d0
          fatcor_hz=1.d0
        ENDIF
        ifirst=0
      endif


* gli indici del primo set sono 1 2 3 4 5 6
*        quelli del secondo     5 2 3 4 1 6
      res=0.d0
      DO i=1,2
        DO i3=1,2
          DO i4=1,2
            IF (imix.EQ.-1.or.imix.eq.-2) then
              cres=cn1(i,i,i3,i4,i,i).i(1)+cn2(i,i,i3,i4,i,i).i(1)+
     &          cn3(i,i,i3,i4,i,i).i(1)+cn4(i,i,i3,i4,i,i).i(1)+
     &          cn5(i,i,i3,i4,i,i).i(1)+cn6(i,i,i3,i4,i,i).i(1)
     &          -cn1(i,i,i3,i4,i,i).i(2)-cn2(i,i,i3,i4,i,i).i(2)-
     &          cn3(i,i,i3,i4,i,i).i(2)-cn4(i,i,i3,i4,i,i).i(2)-
     &          cn5(i,i,i3,i4,i,i).i(2)-cn6(i,i,i3,i4,i,i).i(2)
              res=res+dreal(cres)**2+dimag(cres)**2
            ENDIF
            IF (imix.EQ.1.OR.imix.EQ.-2) then
              cresh=ch(i,i,i3,i4,i,i).i(1)-ch(i,i,i3,i4,i,i).i(2)
              IF (imix.EQ.1) THEN
                res=res+(dreal(cresh)**2+dimag(cresh)**2)*fatcor_hh
              ELSE IF (imix.EQ.-2) then
                res=res+(cres*conjg(cresh)+cresh*conjg(cres))
     &              *fatcor_hz
              ENDIF
            ENDIF
          END DO
        END DO
      END DO
      DO i=1,2
        j=mod(i,2)+1
        DO i3=1,2
          DO i4=1,2
            IF (imix.EQ.-1.or.imix.eq.-2) then
              cres=cn1(i,i,i3,i4,j,j).i(1)+cn2(i,i,i3,i4,j,j).i(1)+
     &          cn3(i,i,i3,i4,j,j).i(1)+cn4(i,i,i3,i4,j,j).i(1)+
     &          cn5(i,i,i3,i4,j,j).i(1)+cn6(i,i,i3,i4,j,j).i(1)
              res=res+dreal(cres)**2+dimag(cres)**2
            ENDIF
            IF (imix.EQ.1.OR.imix.EQ.-2) then
              cresh=ch(i,i,i3,i4,j,j).i(1)
              IF (imix.EQ.1) THEN
                res=res+(dreal(cresh)**2+dimag(cresh)**2)*fatcor_hh
              ELSE IF (imix.EQ.-2) then
                res=res+(cres*conjg(cresh)+cresh*conjg(cres))
     &              *fatcor_hz
              ENDIF
            ENDIF
            IF (imix.EQ.-1.or.imix.eq.-2) then
              cres=-cn1(i,i,i3,i4,j,j).i(2)-cn2(i,i,i3,i4,j,j).i(2)-
     &          cn3(i,i,i3,i4,j,j).i(2)-cn4(i,i,i3,i4,j,j).i(2)-
     &          cn5(i,i,i3,i4,j,j).i(2)-cn6(i,i,i3,i4,j,j).i(2)
              res=res+dreal(cres)**2+dimag(cres)**2
            ENDIF
            IF (imix.EQ.1.OR.imix.EQ.-2) then
              cresh=-ch(i,i,i3,i4,j,j).i(2)
              IF (imix.EQ.1) THEN
                res=res+(dreal(cresh)**2+dimag(cresh)**2)*fatcor_hh
              ELSE IF (imix.EQ.-2) then
                res=res+(cres*conjg(cresh)+cresh*conjg(cres))
     &              *fatcor_hz
              ENDIF
            ENDIF
          END DO
        END DO
      END DO
      rden=4.d0
* el1
      IF(i3q.EQ.1)THEN
        rc=3.d0
      ELSE
        rc=1.d0
      ENDIF
* endel1
      ee_bbee=rc*res/p1k0/p2k0/p3k0/p4k0/p5k0/p6k0/rden
      IF (istrcor.EQ.1) THEN
        ee_bbee=ee_bbee*(1.d0+qcdcor_nc)
      ENDIF

      RETURN
      END

